----------------------------------------------------
--  
--      VHDL code generated by Visual Elite
--
--  Design Unit:
--  ------------
--      Unit    Name  :  XGMII_to_PCS
--      Library Name  :  PCS_verilog
--  
--      Creation Date :  Tue Jul 13 15:26:02 2004
--      Version       :  3.5.1 build 43. Date: Feb 22 2004. License: 2004.2
--  
--  Options Used:
--  -------------
--      Target
--         Language   :  VHDL
--         Purpose    :  Synthesis
--         Vendor     :  Design Compiler
--  
--      Style
--         Use tasks                      :  No
--         Code Destination               :  1 File per Unit
--         Attach Packages                :  No
--         Generate Entity                :  Yes
--         Attach Directives              :  Yes
--         Structural                     :  No
--         Preserve spacing for free text :  Yes
--         Declaration alignment          :  No
--
----------------------------------------------------
----------------------------------------------------
--  
--  Library Name :  PCS_verilog
--  Unit    Name :  XGMII_to_PCS
--  Unit    Type :  Text Unit
--  
------------------------------------------------------
 
-- ---------------- Xilinx, CTD Systems & Apps  ------------------------
--  Start of Coding Date: SUN April 22 2001 ( 2:00 pm)
--  File name: XGMII_to_PCS.v
--  Description: This file has the code for XGMII to PCS code conversion
--               It is used as a part of the encoding function
--   Disclaimer: LIMITED WARRANTY AND DISCLAMER. These designs are
--               provided to you "as is". Xilinx and its licensors make, and you
--               receive no warranties or conditions, express, implied,
--               statutory or otherwise, and Xilinx specifically disclaims any
--               implied warranties of merchantability, non-infringement, or
--               fitness for a particular purpose. Xilinx does not warrant that
--               the functions contained in these designs will meet your
--               requirements, or that the operation of these designs will be
--               uninterrupted or error free, or that defects in the Designs
--               will be corrected. Furthermore, Xilinx does not warrant or
--               make any representations regarding use or the results of the
--               use of the designs in terms of correctness, accuracy,
--               reliability, or otherwise.
--               LIMITATION OF LIABILITY. In no event will Xilinx or its
--               licensors be liable for any loss of data, lost profits, cost
--               or procurement of substitute goods or services, or for any
--               special, incidental, consequential, or indirect damages
--               arising from the use or operation of the designs or
--               accompanying documentation, however caused and on any theory
--               of liability. This limitation will apply even if Xilinx
--               has been advised of the possibility of such damage. This
--               limitation shall apply not-withstanding the failure of the
--               essential purpose of any limited remedies herein.
--   Copyright  2002 Xilinx, Inc.
--   All rights reserved
--                        Revision History
-- -----------------------------------------------------------------
--  Date Modified             User Name            Full Name
--         Descrition of Changes
-- -----------------------------------------------------------------
--  $Log$
-- -----------------------------------------------------------------
--  NOTES:
-- -----------------------------------------------------------------
-- -----------------------------------------------------------------

--library SYNOPSYS;
--use SYNOPSYS.ATTRIBUTES.ALL;
 
 
library ieee;
use ieee.STD_LOGIC_1164.all;
use ieee.STD_LOGIC_ARITH.all;
use ieee.STD_LOGIC_MISC.all;
use ieee.STD_LOGIC_UNSIGNED.all;
 
 
entity XGMII_to_PCS is
  port (
        in_code : in STD_LOGIC_VECTOR(7 downto 0 );
        out_code : out STD_LOGIC_VECTOR(6 downto 0 )
        );
end XGMII_to_PCS;


architecture XGMII_to_PCS of XGMII_to_PCS is
 
begin
 
  process (in_code)
  begin
 
    case in_code is
      when "00011100" =>
        out_code <= "0101101";
 
      when "00111100" =>
        out_code <= "0110011";
 
      when "01111100" =>
        out_code <= "1001011";
 
      when "10111100" =>
        out_code <= "1010101";
 
      when "11011100" =>
        out_code <= "1100110";
 
      when "11110111" =>
        out_code <= "1111000";
 
      when "00000111" =>
        out_code <= "0000000";
                           --  before leaving.
      when "11111110" =>
        out_code <= "0011110";
 
      when others  =>
        out_code <= "1111111";
 
 
        --  for sync state machine
        --  TX code select
        --  For Encoder
        -- `define  EBLOCK_R {`XGMII_error,`XGMII_error,`XGMII_error,`XGMII_error,`XGMII_error,`XGMII_error,`XGMII_error,`XGMII_error}
        -- `define  EBLOCK_T {`PCS_error,`PCS_error,`PCS_error,`PCS_error,`PCS_error,`PCS_error,`PCS_error,`PCS_error,`Type_1,`Sync_cont}
    end case  ;
  end process ;
 
 
end ;

