-- (c) Copyright 1995-2014 Xilinx, Inc. All rights reserved.
-- 
-- This file contains confidential and proprietary information
-- of Xilinx, Inc. and is protected under U.S. and
-- international copyright and other intellectual property
-- laws.
-- 
-- DISCLAIMER
-- This disclaimer is not a license and does not grant any
-- rights to the materials distributed herewith. Except as
-- otherwise provided in a valid license issued to you by
-- Xilinx, and to the maximum extent permitted by applicable
-- law: (1) THESE MATERIALS ARE MADE AVAILABLE "AS IS" AND
-- WITH ALL FAULTS, AND XILINX HEREBY DISCLAIMS ALL WARRANTIES
-- AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY, INCLUDING
-- BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-
-- INFRINGEMENT, OR FITNESS FOR ANY PARTICULAR PURPOSE; and
-- (2) Xilinx shall not be liable (whether in contract or tort,
-- including negligence, or under any other theory of
-- liability) for any loss or damage of any kind or nature
-- related to, arising under or in connection with these
-- materials, including for any direct, or any indirect,
-- special, incidental, or consequential loss or damage
-- (including loss of data, profits, goodwill, or any type of
-- loss or damage suffered as a result of any action brought
-- by a third party) even if such damage or loss was
-- reasonably foreseeable or Xilinx had been advised of the
-- possibility of the same.
-- 
-- CRITICAL APPLICATIONS
-- Xilinx products are not designed or intended to be fail-
-- safe, or for use in any application requiring fail-safe
-- performance, such as life-support or safety devices or
-- systems, Class III medical devices, nuclear facilities,
-- applications related to the deployment of airbags, or any
-- other applications that could lead to death, personal
-- injury, or severe property or environmental damage
-- (individually and collectively, "Critical
-- Applications"). Customer assumes the sole risk and
-- liability of any use of Xilinx products in Critical
-- Applications, subject only to applicable laws and
-- regulations governing limitations on product liability.
-- 
-- THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS
-- PART OF THIS FILE AT ALL TIMES.
-- 
-- DO NOT MODIFY THIS FILE.

-- IP VLNV: cesnet:netcope:eth100g:1.0
-- IP Revision: 9

LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;

LIBRARY xil_defaultlib;
USE xil_defaultlib.eth100g;

ENTITY design_1_eth100g_0_0 IS
  PORT (
    RESET : IN STD_LOGIC;
    DRPCLK : IN STD_LOGIC;
    CFP2_GTZ_REFCLK_P : IN STD_LOGIC;
    CFP2_GTZ_REFCLK_N : IN STD_LOGIC;
    CFP2_RX0_RX1_P : IN STD_LOGIC;
    CFP2_RX0_RX1_N : IN STD_LOGIC;
    CFP2_TX0_TX1_P : OUT STD_LOGIC;
    CFP2_TX0_TX1_N : OUT STD_LOGIC;
    CFP2_RX1_RX2_P : IN STD_LOGIC;
    CFP2_RX1_RX2_N : IN STD_LOGIC;
    CFP2_TX1_TX2_P : OUT STD_LOGIC;
    CFP2_TX1_TX2_N : OUT STD_LOGIC;
    CFP2_RX2_RX5_P : IN STD_LOGIC;
    CFP2_RX2_RX5_N : IN STD_LOGIC;
    CFP2_TX2_TX5_P : OUT STD_LOGIC;
    CFP2_TX2_TX5_N : OUT STD_LOGIC;
    CFP2_RX3_RX6_P : IN STD_LOGIC;
    CFP2_RX3_RX6_N : IN STD_LOGIC;
    CFP2_TX3_TX6_P : OUT STD_LOGIC;
    CFP2_TX3_TX6_N : OUT STD_LOGIC;
    CFP2_GLB_ALRM_N : IN STD_LOGIC;
    CFP2_MOD_ABS : IN STD_LOGIC;
    CFP2_MOD_LOPWR : OUT STD_LOGIC;
    CFP2_MOD_RST_N : OUT STD_LOGIC;
    CFP2_PRG_ALRM1 : IN STD_LOGIC;
    CFP2_PRG_ALRM2 : IN STD_LOGIC;
    CFP2_PRG_ALRM3 : IN STD_LOGIC;
    CFP2_PRG_CNTL1 : OUT STD_LOGIC;
    CFP2_PRG_CNTL2 : OUT STD_LOGIC;
    CFP2_PRG_CNTL3 : OUT STD_LOGIC;
    CFP2_RX_LOS : IN STD_LOGIC;
    CFP2_TX_DIS : OUT STD_LOGIC;
    CFP2_MDC : OUT STD_LOGIC;
    CFP2_MDIO : INOUT STD_LOGIC;
    MI_CLK : IN STD_LOGIC;
    MI_RESET : IN STD_LOGIC;
    ETH_MI_DWR : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
    ETH_MI_ADDR : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
    ETH_MI_RD : IN STD_LOGIC;
    ETH_MI_WR : IN STD_LOGIC;
    ETH_MI_BE : IN STD_LOGIC_VECTOR(3 DOWNTO 0);
    ETH_MI_DRD : OUT STD_LOGIC_VECTOR(31 DOWNTO 0);
    ETH_MI_ARDY : OUT STD_LOGIC;
    ETH_MI_DRDY : OUT STD_LOGIC;
    RX_CLK : IN STD_LOGIC;
    RX_RESET : IN STD_LOGIC;
    RX_DATA : OUT STD_LOGIC_VECTOR(511 DOWNTO 0);
    RX_SOP_POS : OUT STD_LOGIC_VECTOR(2 DOWNTO 0);
    RX_EOP_POS : OUT STD_LOGIC_VECTOR(5 DOWNTO 0);
    RX_SOP : OUT STD_LOGIC;
    RX_EOP : OUT STD_LOGIC;
    RX_SRC_RDY : OUT STD_LOGIC;
    RX_DST_RDY : IN STD_LOGIC;
    RX_HDATA : OUT STD_LOGIC_VECTOR(127 DOWNTO 0);
    RX_HSOP_N : OUT STD_LOGIC;
    RX_HEOP_N : OUT STD_LOGIC;
    RX_HREM : OUT STD_LOGIC_VECTOR(3 DOWNTO 0);
    RX_HSRC_RDY_N : OUT STD_LOGIC;
    RX_HDST_RDY_N : IN STD_LOGIC;
    TX_CLK : IN STD_LOGIC;
    TX_RESET : IN STD_LOGIC;
    TX_DATA : IN STD_LOGIC_VECTOR(511 DOWNTO 0);
    TX_SOP_POS : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
    TX_EOP_POS : IN STD_LOGIC_VECTOR(5 DOWNTO 0);
    TX_SOP : IN STD_LOGIC;
    TX_EOP : IN STD_LOGIC;
    TX_SRC_RDY : IN STD_LOGIC;
    TX_DST_RDY : OUT STD_LOGIC;
    NET_MI_DWR : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
    NET_MI_ADDR : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
    NET_MI_RD : IN STD_LOGIC;
    NET_MI_WR : IN STD_LOGIC;
    NET_MI_BE : IN STD_LOGIC_VECTOR(3 DOWNTO 0);
    NET_MI_DRD : OUT STD_LOGIC_VECTOR(31 DOWNTO 0);
    NET_MI_ARDY : OUT STD_LOGIC;
    NET_MI_DRDY : OUT STD_LOGIC;
    LED_GREEN : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
    LED_RED : OUT STD_LOGIC_VECTOR(7 DOWNTO 0)
  );
END design_1_eth100g_0_0;

ARCHITECTURE design_1_eth100g_0_0_arch OF design_1_eth100g_0_0 IS
  ATTRIBUTE DowngradeIPIdentifiedWarnings : string;
  ATTRIBUTE DowngradeIPIdentifiedWarnings OF design_1_eth100g_0_0_arch: ARCHITECTURE IS "yes";

  COMPONENT eth100g IS
    GENERIC (
      IBUF_DFIFO_BYTES : INTEGER;
      IBUF_HFIFO_BYTES : INTEGER;
      HDR_WIDTH : INTEGER;
      IBUF_MAC_COUNT : INTEGER;
      INBANDFCS : BOOLEAN;
      IBUF_CNT_ERROR_LENGTH : INTEGER;
      OBUF_DFIFO_BYTES : INTEGER;
      OBUF_HFIFO_BYTES : INTEGER;
      LED_CTRL_CNTR_SIZE : INTEGER
    );
    PORT (
      RESET : IN STD_LOGIC;
      DRPCLK : IN STD_LOGIC;
      CFP2_GTZ_REFCLK_P : IN STD_LOGIC;
      CFP2_GTZ_REFCLK_N : IN STD_LOGIC;
      CFP2_RX0_RX1_P : IN STD_LOGIC;
      CFP2_RX0_RX1_N : IN STD_LOGIC;
      CFP2_TX0_TX1_P : OUT STD_LOGIC;
      CFP2_TX0_TX1_N : OUT STD_LOGIC;
      CFP2_RX1_RX2_P : IN STD_LOGIC;
      CFP2_RX1_RX2_N : IN STD_LOGIC;
      CFP2_TX1_TX2_P : OUT STD_LOGIC;
      CFP2_TX1_TX2_N : OUT STD_LOGIC;
      CFP2_RX2_RX5_P : IN STD_LOGIC;
      CFP2_RX2_RX5_N : IN STD_LOGIC;
      CFP2_TX2_TX5_P : OUT STD_LOGIC;
      CFP2_TX2_TX5_N : OUT STD_LOGIC;
      CFP2_RX3_RX6_P : IN STD_LOGIC;
      CFP2_RX3_RX6_N : IN STD_LOGIC;
      CFP2_TX3_TX6_P : OUT STD_LOGIC;
      CFP2_TX3_TX6_N : OUT STD_LOGIC;
      CFP2_GLB_ALRM_N : IN STD_LOGIC;
      CFP2_MOD_ABS : IN STD_LOGIC;
      CFP2_MOD_LOPWR : OUT STD_LOGIC;
      CFP2_MOD_RST_N : OUT STD_LOGIC;
      CFP2_PRG_ALRM1 : IN STD_LOGIC;
      CFP2_PRG_ALRM2 : IN STD_LOGIC;
      CFP2_PRG_ALRM3 : IN STD_LOGIC;
      CFP2_PRG_CNTL1 : OUT STD_LOGIC;
      CFP2_PRG_CNTL2 : OUT STD_LOGIC;
      CFP2_PRG_CNTL3 : OUT STD_LOGIC;
      CFP2_RX_LOS : IN STD_LOGIC;
      CFP2_TX_DIS : OUT STD_LOGIC;
      CFP2_MDC : OUT STD_LOGIC;
      CFP2_MDIO : INOUT STD_LOGIC;
      MI_CLK : IN STD_LOGIC;
      MI_RESET : IN STD_LOGIC;
      ETH_MI_DWR : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
      ETH_MI_ADDR : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
      ETH_MI_RD : IN STD_LOGIC;
      ETH_MI_WR : IN STD_LOGIC;
      ETH_MI_BE : IN STD_LOGIC_VECTOR(3 DOWNTO 0);
      ETH_MI_DRD : OUT STD_LOGIC_VECTOR(31 DOWNTO 0);
      ETH_MI_ARDY : OUT STD_LOGIC;
      ETH_MI_DRDY : OUT STD_LOGIC;
      RX_CLK : IN STD_LOGIC;
      RX_RESET : IN STD_LOGIC;
      RX_DATA : OUT STD_LOGIC_VECTOR(511 DOWNTO 0);
      RX_SOP_POS : OUT STD_LOGIC_VECTOR(2 DOWNTO 0);
      RX_EOP_POS : OUT STD_LOGIC_VECTOR(5 DOWNTO 0);
      RX_SOP : OUT STD_LOGIC;
      RX_EOP : OUT STD_LOGIC;
      RX_SRC_RDY : OUT STD_LOGIC;
      RX_DST_RDY : IN STD_LOGIC;
      RX_HDATA : OUT STD_LOGIC_VECTOR(127 DOWNTO 0);
      RX_HSOP_N : OUT STD_LOGIC;
      RX_HEOP_N : OUT STD_LOGIC;
      RX_HREM : OUT STD_LOGIC_VECTOR(3 DOWNTO 0);
      RX_HSRC_RDY_N : OUT STD_LOGIC;
      RX_HDST_RDY_N : IN STD_LOGIC;
      TX_CLK : IN STD_LOGIC;
      TX_RESET : IN STD_LOGIC;
      TX_DATA : IN STD_LOGIC_VECTOR(511 DOWNTO 0);
      TX_SOP_POS : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
      TX_EOP_POS : IN STD_LOGIC_VECTOR(5 DOWNTO 0);
      TX_SOP : IN STD_LOGIC;
      TX_EOP : IN STD_LOGIC;
      TX_SRC_RDY : IN STD_LOGIC;
      TX_DST_RDY : OUT STD_LOGIC;
      NET_MI_DWR : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
      NET_MI_ADDR : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
      NET_MI_RD : IN STD_LOGIC;
      NET_MI_WR : IN STD_LOGIC;
      NET_MI_BE : IN STD_LOGIC_VECTOR(3 DOWNTO 0);
      NET_MI_DRD : OUT STD_LOGIC_VECTOR(31 DOWNTO 0);
      NET_MI_ARDY : OUT STD_LOGIC;
      NET_MI_DRDY : OUT STD_LOGIC;
      LED_GREEN : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
      LED_RED : OUT STD_LOGIC_VECTOR(7 DOWNTO 0)
    );
  END COMPONENT eth100g;
  ATTRIBUTE X_INTERFACE_INFO : STRING;
  ATTRIBUTE X_INTERFACE_INFO OF CFP2_GTZ_REFCLK_P: SIGNAL IS "xilinx.com:interface:diff_clock:1.0 cfp2_clk CLK_P";
  ATTRIBUTE X_INTERFACE_INFO OF CFP2_GTZ_REFCLK_N: SIGNAL IS "xilinx.com:interface:diff_clock:1.0 cfp2_clk CLK_N";
  ATTRIBUTE X_INTERFACE_INFO OF CFP2_RX0_RX1_P: SIGNAL IS "cesnet:interface:cfp2_diff_data:1.0 cfp2_data CFP2_RX0_P";
  ATTRIBUTE X_INTERFACE_INFO OF CFP2_RX0_RX1_N: SIGNAL IS "cesnet:interface:cfp2_diff_data:1.0 cfp2_data CFP2_RX0_N";
  ATTRIBUTE X_INTERFACE_INFO OF CFP2_TX0_TX1_P: SIGNAL IS "cesnet:interface:cfp2_diff_data:1.0 cfp2_data CFP2_TX0_P";
  ATTRIBUTE X_INTERFACE_INFO OF CFP2_TX0_TX1_N: SIGNAL IS "cesnet:interface:cfp2_diff_data:1.0 cfp2_data CFP2_TX0_N";
  ATTRIBUTE X_INTERFACE_INFO OF CFP2_RX1_RX2_P: SIGNAL IS "cesnet:interface:cfp2_diff_data:1.0 cfp2_data CFP2_RX1_P";
  ATTRIBUTE X_INTERFACE_INFO OF CFP2_RX1_RX2_N: SIGNAL IS "cesnet:interface:cfp2_diff_data:1.0 cfp2_data CFP2_RX1_N";
  ATTRIBUTE X_INTERFACE_INFO OF CFP2_TX1_TX2_P: SIGNAL IS "cesnet:interface:cfp2_diff_data:1.0 cfp2_data CFP2_TX1_P";
  ATTRIBUTE X_INTERFACE_INFO OF CFP2_TX1_TX2_N: SIGNAL IS "cesnet:interface:cfp2_diff_data:1.0 cfp2_data CFP2_TX1_N";
  ATTRIBUTE X_INTERFACE_INFO OF CFP2_RX2_RX5_P: SIGNAL IS "cesnet:interface:cfp2_diff_data:1.0 cfp2_data CFP2_RX2_P";
  ATTRIBUTE X_INTERFACE_INFO OF CFP2_RX2_RX5_N: SIGNAL IS "cesnet:interface:cfp2_diff_data:1.0 cfp2_data CFP2_RX2_N";
  ATTRIBUTE X_INTERFACE_INFO OF CFP2_TX2_TX5_P: SIGNAL IS "cesnet:interface:cfp2_diff_data:1.0 cfp2_data CFP2_TX2_P";
  ATTRIBUTE X_INTERFACE_INFO OF CFP2_TX2_TX5_N: SIGNAL IS "cesnet:interface:cfp2_diff_data:1.0 cfp2_data CFP2_TX2_N";
  ATTRIBUTE X_INTERFACE_INFO OF CFP2_RX3_RX6_P: SIGNAL IS "cesnet:interface:cfp2_diff_data:1.0 cfp2_data CFP2_RX3_P";
  ATTRIBUTE X_INTERFACE_INFO OF CFP2_RX3_RX6_N: SIGNAL IS "cesnet:interface:cfp2_diff_data:1.0 cfp2_data CFP2_RX3_N";
  ATTRIBUTE X_INTERFACE_INFO OF CFP2_TX3_TX6_P: SIGNAL IS "cesnet:interface:cfp2_diff_data:1.0 cfp2_data CFP2_TX3_P";
  ATTRIBUTE X_INTERFACE_INFO OF CFP2_TX3_TX6_N: SIGNAL IS "cesnet:interface:cfp2_diff_data:1.0 cfp2_data CFP2_TX3_N";
  ATTRIBUTE X_INTERFACE_INFO OF CFP2_GLB_ALRM_N: SIGNAL IS "cesnet:interface:cfp2_control:1.0 cfp2_control GLB_ALRM_N";
  ATTRIBUTE X_INTERFACE_INFO OF CFP2_MOD_ABS: SIGNAL IS "cesnet:interface:cfp2_control:1.0 cfp2_control MOD_ABS";
  ATTRIBUTE X_INTERFACE_INFO OF CFP2_MOD_LOPWR: SIGNAL IS "cesnet:interface:cfp2_control:1.0 cfp2_control MOD_LOPWR";
  ATTRIBUTE X_INTERFACE_INFO OF CFP2_MOD_RST_N: SIGNAL IS "cesnet:interface:cfp2_control:1.0 cfp2_control MOD_RST_N";
  ATTRIBUTE X_INTERFACE_INFO OF CFP2_PRG_ALRM1: SIGNAL IS "cesnet:interface:cfp2_control:1.0 cfp2_control PRG_ALRM1";
  ATTRIBUTE X_INTERFACE_INFO OF CFP2_PRG_ALRM2: SIGNAL IS "cesnet:interface:cfp2_control:1.0 cfp2_control PRG_ALRM2";
  ATTRIBUTE X_INTERFACE_INFO OF CFP2_PRG_ALRM3: SIGNAL IS "cesnet:interface:cfp2_control:1.0 cfp2_control PRG_ALRM3";
  ATTRIBUTE X_INTERFACE_INFO OF CFP2_PRG_CNTL1: SIGNAL IS "cesnet:interface:cfp2_control:1.0 cfp2_control PRG_CNTL1";
  ATTRIBUTE X_INTERFACE_INFO OF CFP2_PRG_CNTL2: SIGNAL IS "cesnet:interface:cfp2_control:1.0 cfp2_control PRG_CNTL2";
  ATTRIBUTE X_INTERFACE_INFO OF CFP2_PRG_CNTL3: SIGNAL IS "cesnet:interface:cfp2_control:1.0 cfp2_control PRG_CNTL3";
  ATTRIBUTE X_INTERFACE_INFO OF CFP2_RX_LOS: SIGNAL IS "cesnet:interface:cfp2_control:1.0 cfp2_control RX_LOS";
  ATTRIBUTE X_INTERFACE_INFO OF CFP2_TX_DIS: SIGNAL IS "cesnet:interface:cfp2_control:1.0 cfp2_control TX_DIS";
  ATTRIBUTE X_INTERFACE_INFO OF CFP2_MDC: SIGNAL IS "cesnet:interface:cfp2_control:1.0 cfp2_control MDC";
  ATTRIBUTE X_INTERFACE_INFO OF CFP2_MDIO: SIGNAL IS "cesnet:interface:cfp2_control:1.0 cfp2_control MDIO";
  ATTRIBUTE X_INTERFACE_INFO OF ETH_MI_DWR: SIGNAL IS "cesnet:interface:mi_int:1.0 eth_mi MI_DWR";
  ATTRIBUTE X_INTERFACE_INFO OF ETH_MI_ADDR: SIGNAL IS "cesnet:interface:mi_int:1.0 eth_mi MI_ADDR";
  ATTRIBUTE X_INTERFACE_INFO OF ETH_MI_RD: SIGNAL IS "cesnet:interface:mi_int:1.0 eth_mi MI_RD";
  ATTRIBUTE X_INTERFACE_INFO OF ETH_MI_WR: SIGNAL IS "cesnet:interface:mi_int:1.0 eth_mi MI_WR";
  ATTRIBUTE X_INTERFACE_INFO OF ETH_MI_BE: SIGNAL IS "cesnet:interface:mi_int:1.0 eth_mi MI_BE";
  ATTRIBUTE X_INTERFACE_INFO OF ETH_MI_DRD: SIGNAL IS "cesnet:interface:mi_int:1.0 eth_mi MI_DRD";
  ATTRIBUTE X_INTERFACE_INFO OF ETH_MI_ARDY: SIGNAL IS "cesnet:interface:mi_int:1.0 eth_mi MI_ARDY";
  ATTRIBUTE X_INTERFACE_INFO OF ETH_MI_DRDY: SIGNAL IS "cesnet:interface:mi_int:1.0 eth_mi MI_DRDY";
  ATTRIBUTE X_INTERFACE_INFO OF RX_DATA: SIGNAL IS "cesnet:interface:flu:1.0 rx_flu DATA";
  ATTRIBUTE X_INTERFACE_INFO OF RX_SOP_POS: SIGNAL IS "cesnet:interface:flu:1.0 rx_flu SOP_POS";
  ATTRIBUTE X_INTERFACE_INFO OF RX_EOP_POS: SIGNAL IS "cesnet:interface:flu:1.0 rx_flu EOP_POS";
  ATTRIBUTE X_INTERFACE_INFO OF RX_SOP: SIGNAL IS "cesnet:interface:flu:1.0 rx_flu SOP";
  ATTRIBUTE X_INTERFACE_INFO OF RX_EOP: SIGNAL IS "cesnet:interface:flu:1.0 rx_flu EOP";
  ATTRIBUTE X_INTERFACE_INFO OF RX_SRC_RDY: SIGNAL IS "cesnet:interface:flu:1.0 rx_flu SRC_RDY";
  ATTRIBUTE X_INTERFACE_INFO OF RX_DST_RDY: SIGNAL IS "cesnet:interface:flu:1.0 rx_flu DST_RDY";
  ATTRIBUTE X_INTERFACE_INFO OF RX_HDATA: SIGNAL IS "cesnet:interface:fl:1.0 rx_fl DATA";
  ATTRIBUTE X_INTERFACE_INFO OF RX_HSOP_N: SIGNAL IS "cesnet:interface:fl:1.0 rx_fl SOP_N";
  ATTRIBUTE X_INTERFACE_INFO OF RX_HEOP_N: SIGNAL IS "cesnet:interface:fl:1.0 rx_fl EOP_N";
  ATTRIBUTE X_INTERFACE_INFO OF RX_HREM: SIGNAL IS "cesnet:interface:fl:1.0 rx_fl REM";
  ATTRIBUTE X_INTERFACE_INFO OF RX_HSRC_RDY_N: SIGNAL IS "cesnet:interface:fl:1.0 rx_fl SRC_RDY_N";
  ATTRIBUTE X_INTERFACE_INFO OF RX_HDST_RDY_N: SIGNAL IS "cesnet:interface:fl:1.0 rx_fl DST_RDY_N";
  ATTRIBUTE X_INTERFACE_INFO OF TX_DATA: SIGNAL IS "cesnet:interface:flu:1.0 tx_flu DATA";
  ATTRIBUTE X_INTERFACE_INFO OF TX_SOP_POS: SIGNAL IS "cesnet:interface:flu:1.0 tx_flu SOP_POS";
  ATTRIBUTE X_INTERFACE_INFO OF TX_EOP_POS: SIGNAL IS "cesnet:interface:flu:1.0 tx_flu EOP_POS";
  ATTRIBUTE X_INTERFACE_INFO OF TX_SOP: SIGNAL IS "cesnet:interface:flu:1.0 tx_flu SOP";
  ATTRIBUTE X_INTERFACE_INFO OF TX_EOP: SIGNAL IS "cesnet:interface:flu:1.0 tx_flu EOP";
  ATTRIBUTE X_INTERFACE_INFO OF TX_SRC_RDY: SIGNAL IS "cesnet:interface:flu:1.0 tx_flu SRC_RDY";
  ATTRIBUTE X_INTERFACE_INFO OF TX_DST_RDY: SIGNAL IS "cesnet:interface:flu:1.0 tx_flu DST_RDY";
  ATTRIBUTE X_INTERFACE_INFO OF NET_MI_DWR: SIGNAL IS "cesnet:interface:mi_int:1.0 net_mi MI_DWR";
  ATTRIBUTE X_INTERFACE_INFO OF NET_MI_ADDR: SIGNAL IS "cesnet:interface:mi_int:1.0 net_mi MI_ADDR";
  ATTRIBUTE X_INTERFACE_INFO OF NET_MI_RD: SIGNAL IS "cesnet:interface:mi_int:1.0 net_mi MI_RD";
  ATTRIBUTE X_INTERFACE_INFO OF NET_MI_WR: SIGNAL IS "cesnet:interface:mi_int:1.0 net_mi MI_WR";
  ATTRIBUTE X_INTERFACE_INFO OF NET_MI_BE: SIGNAL IS "cesnet:interface:mi_int:1.0 net_mi MI_BE";
  ATTRIBUTE X_INTERFACE_INFO OF NET_MI_DRD: SIGNAL IS "cesnet:interface:mi_int:1.0 net_mi MI_DRD";
  ATTRIBUTE X_INTERFACE_INFO OF NET_MI_ARDY: SIGNAL IS "cesnet:interface:mi_int:1.0 net_mi MI_ARDY";
  ATTRIBUTE X_INTERFACE_INFO OF NET_MI_DRDY: SIGNAL IS "cesnet:interface:mi_int:1.0 net_mi MI_DRDY";
  ATTRIBUTE X_INTERFACE_INFO OF LED_GREEN: SIGNAL IS "cesnet:interface:leds_interface:1.0 leds_interface LED_GREEN";
  ATTRIBUTE X_INTERFACE_INFO OF LED_RED: SIGNAL IS "cesnet:interface:leds_interface:1.0 leds_interface LED_RED";
BEGIN
  U0 : eth100g
    GENERIC MAP (
      IBUF_DFIFO_BYTES => 4096,
      IBUF_HFIFO_BYTES => 1024,
      HDR_WIDTH => 128,
      IBUF_MAC_COUNT => 16,
      INBANDFCS => false,
      IBUF_CNT_ERROR_LENGTH => 5,
      OBUF_DFIFO_BYTES => 4096,
      OBUF_HFIFO_BYTES => 1024,
      LED_CTRL_CNTR_SIZE => 27
    )
    PORT MAP (
      RESET => RESET,
      DRPCLK => DRPCLK,
      CFP2_GTZ_REFCLK_P => CFP2_GTZ_REFCLK_P,
      CFP2_GTZ_REFCLK_N => CFP2_GTZ_REFCLK_N,
      CFP2_RX0_RX1_P => CFP2_RX0_RX1_P,
      CFP2_RX0_RX1_N => CFP2_RX0_RX1_N,
      CFP2_TX0_TX1_P => CFP2_TX0_TX1_P,
      CFP2_TX0_TX1_N => CFP2_TX0_TX1_N,
      CFP2_RX1_RX2_P => CFP2_RX1_RX2_P,
      CFP2_RX1_RX2_N => CFP2_RX1_RX2_N,
      CFP2_TX1_TX2_P => CFP2_TX1_TX2_P,
      CFP2_TX1_TX2_N => CFP2_TX1_TX2_N,
      CFP2_RX2_RX5_P => CFP2_RX2_RX5_P,
      CFP2_RX2_RX5_N => CFP2_RX2_RX5_N,
      CFP2_TX2_TX5_P => CFP2_TX2_TX5_P,
      CFP2_TX2_TX5_N => CFP2_TX2_TX5_N,
      CFP2_RX3_RX6_P => CFP2_RX3_RX6_P,
      CFP2_RX3_RX6_N => CFP2_RX3_RX6_N,
      CFP2_TX3_TX6_P => CFP2_TX3_TX6_P,
      CFP2_TX3_TX6_N => CFP2_TX3_TX6_N,
      CFP2_GLB_ALRM_N => CFP2_GLB_ALRM_N,
      CFP2_MOD_ABS => CFP2_MOD_ABS,
      CFP2_MOD_LOPWR => CFP2_MOD_LOPWR,
      CFP2_MOD_RST_N => CFP2_MOD_RST_N,
      CFP2_PRG_ALRM1 => CFP2_PRG_ALRM1,
      CFP2_PRG_ALRM2 => CFP2_PRG_ALRM2,
      CFP2_PRG_ALRM3 => CFP2_PRG_ALRM3,
      CFP2_PRG_CNTL1 => CFP2_PRG_CNTL1,
      CFP2_PRG_CNTL2 => CFP2_PRG_CNTL2,
      CFP2_PRG_CNTL3 => CFP2_PRG_CNTL3,
      CFP2_RX_LOS => CFP2_RX_LOS,
      CFP2_TX_DIS => CFP2_TX_DIS,
      CFP2_MDC => CFP2_MDC,
      CFP2_MDIO => CFP2_MDIO,
      MI_CLK => MI_CLK,
      MI_RESET => MI_RESET,
      ETH_MI_DWR => ETH_MI_DWR,
      ETH_MI_ADDR => ETH_MI_ADDR,
      ETH_MI_RD => ETH_MI_RD,
      ETH_MI_WR => ETH_MI_WR,
      ETH_MI_BE => ETH_MI_BE,
      ETH_MI_DRD => ETH_MI_DRD,
      ETH_MI_ARDY => ETH_MI_ARDY,
      ETH_MI_DRDY => ETH_MI_DRDY,
      RX_CLK => RX_CLK,
      RX_RESET => RX_RESET,
      RX_DATA => RX_DATA,
      RX_SOP_POS => RX_SOP_POS,
      RX_EOP_POS => RX_EOP_POS,
      RX_SOP => RX_SOP,
      RX_EOP => RX_EOP,
      RX_SRC_RDY => RX_SRC_RDY,
      RX_DST_RDY => RX_DST_RDY,
      RX_HDATA => RX_HDATA,
      RX_HSOP_N => RX_HSOP_N,
      RX_HEOP_N => RX_HEOP_N,
      RX_HREM => RX_HREM,
      RX_HSRC_RDY_N => RX_HSRC_RDY_N,
      RX_HDST_RDY_N => RX_HDST_RDY_N,
      TX_CLK => TX_CLK,
      TX_RESET => TX_RESET,
      TX_DATA => TX_DATA,
      TX_SOP_POS => TX_SOP_POS,
      TX_EOP_POS => TX_EOP_POS,
      TX_SOP => TX_SOP,
      TX_EOP => TX_EOP,
      TX_SRC_RDY => TX_SRC_RDY,
      TX_DST_RDY => TX_DST_RDY,
      NET_MI_DWR => NET_MI_DWR,
      NET_MI_ADDR => NET_MI_ADDR,
      NET_MI_RD => NET_MI_RD,
      NET_MI_WR => NET_MI_WR,
      NET_MI_BE => NET_MI_BE,
      NET_MI_DRD => NET_MI_DRD,
      NET_MI_ARDY => NET_MI_ARDY,
      NET_MI_DRDY => NET_MI_DRDY,
      LED_GREEN => LED_GREEN,
      LED_RED => LED_RED
    );
END design_1_eth100g_0_0_arch;
