-- (c) Copyright 1995-2014 Xilinx, Inc. All rights reserved.
-- 
-- This file contains confidential and proprietary information
-- of Xilinx, Inc. and is protected under U.S. and
-- international copyright and other intellectual property
-- laws.
-- 
-- DISCLAIMER
-- This disclaimer is not a license and does not grant any
-- rights to the materials distributed herewith. Except as
-- otherwise provided in a valid license issued to you by
-- Xilinx, and to the maximum extent permitted by applicable
-- law: (1) THESE MATERIALS ARE MADE AVAILABLE "AS IS" AND
-- WITH ALL FAULTS, AND XILINX HEREBY DISCLAIMS ALL WARRANTIES
-- AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY, INCLUDING
-- BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-
-- INFRINGEMENT, OR FITNESS FOR ANY PARTICULAR PURPOSE; and
-- (2) Xilinx shall not be liable (whether in contract or tort,
-- including negligence, or under any other theory of
-- liability) for any loss or damage of any kind or nature
-- related to, arising under or in connection with these
-- materials, including for any direct, or any indirect,
-- special, incidental, or consequential loss or damage
-- (including loss of data, profits, goodwill, or any type of
-- loss or damage suffered as a result of any action brought
-- by a third party) even if such damage or loss was
-- reasonably foreseeable or Xilinx had been advised of the
-- possibility of the same.
-- 
-- CRITICAL APPLICATIONS
-- Xilinx products are not designed or intended to be fail-
-- safe, or for use in any application requiring fail-safe
-- performance, such as life-support or safety devices or
-- systems, Class III medical devices, nuclear facilities,
-- applications related to the deployment of airbags, or any
-- other applications that could lead to death, personal
-- injury, or severe property or environmental damage
-- (individually and collectively, "Critical
-- Applications"). Customer assumes the sole risk and
-- liability of any use of Xilinx products in Critical
-- Applications, subject only to applicable laws and
-- regulations governing limitations on product liability.
-- 
-- THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS
-- PART OF THIS FILE AT ALL TIMES.
-- 
-- DO NOT MODIFY THIS FILE.

-- IP VLNV: but:application:filter_core:1.0
-- IP Revision: 1

-- The following code must appear in the VHDL architecture header.

------------- Begin Cut here for COMPONENT Declaration ------ COMP_TAG
COMPONENT design_1_filter_core_0_0
  PORT (
    CLK : IN STD_LOGIC;
    RESET : IN STD_LOGIC;
    RX_DATA : IN STD_LOGIC_VECTOR(511 DOWNTO 0);
    RX_SOP_POS : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
    RX_EOP_POS : IN STD_LOGIC_VECTOR(5 DOWNTO 0);
    RX_SOP : IN STD_LOGIC;
    RX_EOP : IN STD_LOGIC;
    RX_SRC_RDY : IN STD_LOGIC;
    RX_DST_RDY : OUT STD_LOGIC;
    RX_HDATA : IN STD_LOGIC_VECTOR(127 DOWNTO 0);
    RX_HSOP_N : IN STD_LOGIC;
    RX_HEOP_N : IN STD_LOGIC;
    RX_HREM : IN STD_LOGIC_VECTOR(3 DOWNTO 0);
    RX_HSRC_RDY_N : IN STD_LOGIC;
    RX_HDST_RDY_N : OUT STD_LOGIC;
    TX_DATA : OUT STD_LOGIC_VECTOR(511 DOWNTO 0);
    TX_SOP_POS : OUT STD_LOGIC_VECTOR(2 DOWNTO 0);
    TX_EOP_POS : OUT STD_LOGIC_VECTOR(5 DOWNTO 0);
    TX_SOP : OUT STD_LOGIC;
    TX_EOP : OUT STD_LOGIC;
    TX_SRC_RDY : OUT STD_LOGIC;
    TX_DST_RDY : IN STD_LOGIC;
    MI_CLK : IN STD_LOGIC;
    MI_RESET : IN STD_LOGIC;
    MI_DWR : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
    MI_ADDR : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
    MI_RD : IN STD_LOGIC;
    MI_WR : IN STD_LOGIC;
    MI_BE : IN STD_LOGIC_VECTOR(3 DOWNTO 0);
    MI_DRD : OUT STD_LOGIC_VECTOR(31 DOWNTO 0);
    MI_ARDY : OUT STD_LOGIC;
    MI_DRDY : OUT STD_LOGIC
  );
END COMPONENT;
-- COMP_TAG_END ------ End COMPONENT Declaration ------------

-- The following code must appear in the VHDL architecture
-- body. Substitute your own instance name and net names.

------------- Begin Cut here for INSTANTIATION Template ----- INST_TAG
your_instance_name : design_1_filter_core_0_0
  PORT MAP (
    CLK => CLK,
    RESET => RESET,
    RX_DATA => RX_DATA,
    RX_SOP_POS => RX_SOP_POS,
    RX_EOP_POS => RX_EOP_POS,
    RX_SOP => RX_SOP,
    RX_EOP => RX_EOP,
    RX_SRC_RDY => RX_SRC_RDY,
    RX_DST_RDY => RX_DST_RDY,
    RX_HDATA => RX_HDATA,
    RX_HSOP_N => RX_HSOP_N,
    RX_HEOP_N => RX_HEOP_N,
    RX_HREM => RX_HREM,
    RX_HSRC_RDY_N => RX_HSRC_RDY_N,
    RX_HDST_RDY_N => RX_HDST_RDY_N,
    TX_DATA => TX_DATA,
    TX_SOP_POS => TX_SOP_POS,
    TX_EOP_POS => TX_EOP_POS,
    TX_SOP => TX_SOP,
    TX_EOP => TX_EOP,
    TX_SRC_RDY => TX_SRC_RDY,
    TX_DST_RDY => TX_DST_RDY,
    MI_CLK => MI_CLK,
    MI_RESET => MI_RESET,
    MI_DWR => MI_DWR,
    MI_ADDR => MI_ADDR,
    MI_RD => MI_RD,
    MI_WR => MI_WR,
    MI_BE => MI_BE,
    MI_DRD => MI_DRD,
    MI_ARDY => MI_ARDY,
    MI_DRDY => MI_DRDY
  );
-- INST_TAG_END ------ End INSTANTIATION Template ---------

