-- (c) Copyright 1995-2014 Xilinx, Inc. All rights reserved.
-- 
-- This file contains confidential and proprietary information
-- of Xilinx, Inc. and is protected under U.S. and
-- international copyright and other intellectual property
-- laws.
-- 
-- DISCLAIMER
-- This disclaimer is not a license and does not grant any
-- rights to the materials distributed herewith. Except as
-- otherwise provided in a valid license issued to you by
-- Xilinx, and to the maximum extent permitted by applicable
-- law: (1) THESE MATERIALS ARE MADE AVAILABLE "AS IS" AND
-- WITH ALL FAULTS, AND XILINX HEREBY DISCLAIMS ALL WARRANTIES
-- AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY, INCLUDING
-- BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-
-- INFRINGEMENT, OR FITNESS FOR ANY PARTICULAR PURPOSE; and
-- (2) Xilinx shall not be liable (whether in contract or tort,
-- including negligence, or under any other theory of
-- liability) for any loss or damage of any kind or nature
-- related to, arising under or in connection with these
-- materials, including for any direct, or any indirect,
-- special, incidental, or consequential loss or damage
-- (including loss of data, profits, goodwill, or any type of
-- loss or damage suffered as a result of any action brought
-- by a third party) even if such damage or loss was
-- reasonably foreseeable or Xilinx had been advised of the
-- possibility of the same.
-- 
-- CRITICAL APPLICATIONS
-- Xilinx products are not designed or intended to be fail-
-- safe, or for use in any application requiring fail-safe
-- performance, such as life-support or safety devices or
-- systems, Class III medical devices, nuclear facilities,
-- applications related to the deployment of airbags, or any
-- other applications that could lead to death, personal
-- injury, or severe property or environmental damage
-- (individually and collectively, "Critical
-- Applications"). Customer assumes the sole risk and
-- liability of any use of Xilinx products in Critical
-- Applications, subject only to applicable laws and
-- regulations governing limitations on product liability.
-- 
-- THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS
-- PART OF THIS FILE AT ALL TIMES.
-- 
-- DO NOT MODIFY THIS FILE.

-- IP VLNV: cesnet:netcope:host_int:1.0
-- IP Revision: 6

-- The following code must appear in the VHDL architecture header.

------------- Begin Cut here for COMPONENT Declaration ------ COMP_TAG
COMPONENT design_1_host_int_0_0
  PORT (
    PCIE0_SYS_CLK_P : IN STD_LOGIC;
    PCIE0_SYS_CLK_N : IN STD_LOGIC;
    PCIE1_SYS_CLK_P : IN STD_LOGIC;
    PCIE1_SYS_CLK_N : IN STD_LOGIC;
    PCIE_SYS_RESET_N : IN STD_LOGIC;
    PCI1_EXP_RXP : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
    PCI1_EXP_RXN : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
    PCI1_EXP_TXP : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
    PCI1_EXP_TXN : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
    CLK125_P : IN STD_LOGIC;
    CLK125_N : IN STD_LOGIC;
    BF_CLK : OUT STD_LOGIC;
    BF_NSS : OUT STD_LOGIC;
    BF_MOSI : OUT STD_LOGIC;
    BF_MISO : IN STD_LOGIC;
    DRPCLK : OUT STD_LOGIC;
    RESET : OUT STD_LOGIC;
    USER_CLK : OUT STD_LOGIC;
    USER_RESET : OUT STD_LOGIC;
    RX_DATA : IN STD_LOGIC_VECTOR(511 DOWNTO 0);
    RX_SOP_POS : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
    RX_EOP_POS : IN STD_LOGIC_VECTOR(5 DOWNTO 0);
    RX_SOP : IN STD_LOGIC;
    RX_EOP : IN STD_LOGIC;
    RX_SRC_RDY : IN STD_LOGIC;
    RX_DST_RDY : OUT STD_LOGIC;
    TX_DATA : OUT STD_LOGIC_VECTOR(511 DOWNTO 0);
    TX_SOP_POS : OUT STD_LOGIC_VECTOR(2 DOWNTO 0);
    TX_EOP_POS : OUT STD_LOGIC_VECTOR(5 DOWNTO 0);
    TX_SOP : OUT STD_LOGIC;
    TX_EOP : OUT STD_LOGIC;
    TX_SRC_RDY : OUT STD_LOGIC;
    TX_DST_RDY : IN STD_LOGIC;
    MI_CLK : OUT STD_LOGIC;
    MI_RESET : OUT STD_LOGIC;
    ETH_MI_DWR : OUT STD_LOGIC_VECTOR(31 DOWNTO 0);
    ETH_MI_ADDR : OUT STD_LOGIC_VECTOR(31 DOWNTO 0);
    ETH_MI_RD : OUT STD_LOGIC;
    ETH_MI_WR : OUT STD_LOGIC;
    ETH_MI_BE : OUT STD_LOGIC_VECTOR(3 DOWNTO 0);
    ETH_MI_DRD : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
    ETH_MI_ARDY : IN STD_LOGIC;
    ETH_MI_DRDY : IN STD_LOGIC;
    NET_MI_DWR : OUT STD_LOGIC_VECTOR(31 DOWNTO 0);
    NET_MI_ADDR : OUT STD_LOGIC_VECTOR(31 DOWNTO 0);
    NET_MI_RD : OUT STD_LOGIC;
    NET_MI_WR : OUT STD_LOGIC;
    NET_MI_BE : OUT STD_LOGIC_VECTOR(3 DOWNTO 0);
    NET_MI_DRD : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
    NET_MI_ARDY : IN STD_LOGIC;
    NET_MI_DRDY : IN STD_LOGIC;
    USER_MI_DWR : OUT STD_LOGIC_VECTOR(31 DOWNTO 0);
    USER_MI_ADDR : OUT STD_LOGIC_VECTOR(31 DOWNTO 0);
    USER_MI_RD : OUT STD_LOGIC;
    USER_MI_WR : OUT STD_LOGIC;
    USER_MI_BE : OUT STD_LOGIC_VECTOR(3 DOWNTO 0);
    USER_MI_DRD : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
    USER_MI_ARDY : IN STD_LOGIC;
    USER_MI_DRDY : IN STD_LOGIC
  );
END COMPONENT;
-- COMP_TAG_END ------ End COMPONENT Declaration ------------

-- The following code must appear in the VHDL architecture
-- body. Substitute your own instance name and net names.

------------- Begin Cut here for INSTANTIATION Template ----- INST_TAG
your_instance_name : design_1_host_int_0_0
  PORT MAP (
    PCIE0_SYS_CLK_P => PCIE0_SYS_CLK_P,
    PCIE0_SYS_CLK_N => PCIE0_SYS_CLK_N,
    PCIE1_SYS_CLK_P => PCIE1_SYS_CLK_P,
    PCIE1_SYS_CLK_N => PCIE1_SYS_CLK_N,
    PCIE_SYS_RESET_N => PCIE_SYS_RESET_N,
    PCI1_EXP_RXP => PCI1_EXP_RXP,
    PCI1_EXP_RXN => PCI1_EXP_RXN,
    PCI1_EXP_TXP => PCI1_EXP_TXP,
    PCI1_EXP_TXN => PCI1_EXP_TXN,
    CLK125_P => CLK125_P,
    CLK125_N => CLK125_N,
    BF_CLK => BF_CLK,
    BF_NSS => BF_NSS,
    BF_MOSI => BF_MOSI,
    BF_MISO => BF_MISO,
    DRPCLK => DRPCLK,
    RESET => RESET,
    USER_CLK => USER_CLK,
    USER_RESET => USER_RESET,
    RX_DATA => RX_DATA,
    RX_SOP_POS => RX_SOP_POS,
    RX_EOP_POS => RX_EOP_POS,
    RX_SOP => RX_SOP,
    RX_EOP => RX_EOP,
    RX_SRC_RDY => RX_SRC_RDY,
    RX_DST_RDY => RX_DST_RDY,
    TX_DATA => TX_DATA,
    TX_SOP_POS => TX_SOP_POS,
    TX_EOP_POS => TX_EOP_POS,
    TX_SOP => TX_SOP,
    TX_EOP => TX_EOP,
    TX_SRC_RDY => TX_SRC_RDY,
    TX_DST_RDY => TX_DST_RDY,
    MI_CLK => MI_CLK,
    MI_RESET => MI_RESET,
    ETH_MI_DWR => ETH_MI_DWR,
    ETH_MI_ADDR => ETH_MI_ADDR,
    ETH_MI_RD => ETH_MI_RD,
    ETH_MI_WR => ETH_MI_WR,
    ETH_MI_BE => ETH_MI_BE,
    ETH_MI_DRD => ETH_MI_DRD,
    ETH_MI_ARDY => ETH_MI_ARDY,
    ETH_MI_DRDY => ETH_MI_DRDY,
    NET_MI_DWR => NET_MI_DWR,
    NET_MI_ADDR => NET_MI_ADDR,
    NET_MI_RD => NET_MI_RD,
    NET_MI_WR => NET_MI_WR,
    NET_MI_BE => NET_MI_BE,
    NET_MI_DRD => NET_MI_DRD,
    NET_MI_ARDY => NET_MI_ARDY,
    NET_MI_DRDY => NET_MI_DRDY,
    USER_MI_DWR => USER_MI_DWR,
    USER_MI_ADDR => USER_MI_ADDR,
    USER_MI_RD => USER_MI_RD,
    USER_MI_WR => USER_MI_WR,
    USER_MI_BE => USER_MI_BE,
    USER_MI_DRD => USER_MI_DRD,
    USER_MI_ARDY => USER_MI_ARDY,
    USER_MI_DRDY => USER_MI_DRDY
  );
-- INST_TAG_END ------ End INSTANTIATION Template ---------

