-- (c) Copyright 1995-2014 Xilinx, Inc. All rights reserved.
-- 
-- This file contains confidential and proprietary information
-- of Xilinx, Inc. and is protected under U.S. and
-- international copyright and other intellectual property
-- laws.
-- 
-- DISCLAIMER
-- This disclaimer is not a license and does not grant any
-- rights to the materials distributed herewith. Except as
-- otherwise provided in a valid license issued to you by
-- Xilinx, and to the maximum extent permitted by applicable
-- law: (1) THESE MATERIALS ARE MADE AVAILABLE "AS IS" AND
-- WITH ALL FAULTS, AND XILINX HEREBY DISCLAIMS ALL WARRANTIES
-- AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY, INCLUDING
-- BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-
-- INFRINGEMENT, OR FITNESS FOR ANY PARTICULAR PURPOSE; and
-- (2) Xilinx shall not be liable (whether in contract or tort,
-- including negligence, or under any other theory of
-- liability) for any loss or damage of any kind or nature
-- related to, arising under or in connection with these
-- materials, including for any direct, or any indirect,
-- special, incidental, or consequential loss or damage
-- (including loss of data, profits, goodwill, or any type of
-- loss or damage suffered as a result of any action brought
-- by a third party) even if such damage or loss was
-- reasonably foreseeable or Xilinx had been advised of the
-- possibility of the same.
-- 
-- CRITICAL APPLICATIONS
-- Xilinx products are not designed or intended to be fail-
-- safe, or for use in any application requiring fail-safe
-- performance, such as life-support or safety devices or
-- systems, Class III medical devices, nuclear facilities,
-- applications related to the deployment of airbags, or any
-- other applications that could lead to death, personal
-- injury, or severe property or environmental damage
-- (individually and collectively, "Critical
-- Applications"). Customer assumes the sole risk and
-- liability of any use of Xilinx products in Critical
-- Applications, subject only to applicable laws and
-- regulations governing limitations on product liability.
-- 
-- THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS
-- PART OF THIS FILE AT ALL TIMES.
-- 
-- DO NOT MODIFY THIS FILE.

-- IP VLNV: cesnet:netcope:host_int:1.0
-- IP Revision: 6

LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;

LIBRARY xil_defaultlib;
USE xil_defaultlib.host_int;

ENTITY design_1_host_int_0_0 IS
  PORT (
    PCIE0_SYS_CLK_P : IN STD_LOGIC;
    PCIE0_SYS_CLK_N : IN STD_LOGIC;
    PCIE1_SYS_CLK_P : IN STD_LOGIC;
    PCIE1_SYS_CLK_N : IN STD_LOGIC;
    PCIE_SYS_RESET_N : IN STD_LOGIC;
    PCI1_EXP_RXP : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
    PCI1_EXP_RXN : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
    PCI1_EXP_TXP : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
    PCI1_EXP_TXN : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
    CLK125_P : IN STD_LOGIC;
    CLK125_N : IN STD_LOGIC;
    BF_CLK : OUT STD_LOGIC;
    BF_NSS : OUT STD_LOGIC;
    BF_MOSI : OUT STD_LOGIC;
    BF_MISO : IN STD_LOGIC;
    DRPCLK : OUT STD_LOGIC;
    RESET : OUT STD_LOGIC;
    USER_CLK : OUT STD_LOGIC;
    USER_RESET : OUT STD_LOGIC;
    RX_DATA : IN STD_LOGIC_VECTOR(511 DOWNTO 0);
    RX_SOP_POS : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
    RX_EOP_POS : IN STD_LOGIC_VECTOR(5 DOWNTO 0);
    RX_SOP : IN STD_LOGIC;
    RX_EOP : IN STD_LOGIC;
    RX_SRC_RDY : IN STD_LOGIC;
    RX_DST_RDY : OUT STD_LOGIC;
    TX_DATA : OUT STD_LOGIC_VECTOR(511 DOWNTO 0);
    TX_SOP_POS : OUT STD_LOGIC_VECTOR(2 DOWNTO 0);
    TX_EOP_POS : OUT STD_LOGIC_VECTOR(5 DOWNTO 0);
    TX_SOP : OUT STD_LOGIC;
    TX_EOP : OUT STD_LOGIC;
    TX_SRC_RDY : OUT STD_LOGIC;
    TX_DST_RDY : IN STD_LOGIC;
    MI_CLK : OUT STD_LOGIC;
    MI_RESET : OUT STD_LOGIC;
    ETH_MI_DWR : OUT STD_LOGIC_VECTOR(31 DOWNTO 0);
    ETH_MI_ADDR : OUT STD_LOGIC_VECTOR(31 DOWNTO 0);
    ETH_MI_RD : OUT STD_LOGIC;
    ETH_MI_WR : OUT STD_LOGIC;
    ETH_MI_BE : OUT STD_LOGIC_VECTOR(3 DOWNTO 0);
    ETH_MI_DRD : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
    ETH_MI_ARDY : IN STD_LOGIC;
    ETH_MI_DRDY : IN STD_LOGIC;
    NET_MI_DWR : OUT STD_LOGIC_VECTOR(31 DOWNTO 0);
    NET_MI_ADDR : OUT STD_LOGIC_VECTOR(31 DOWNTO 0);
    NET_MI_RD : OUT STD_LOGIC;
    NET_MI_WR : OUT STD_LOGIC;
    NET_MI_BE : OUT STD_LOGIC_VECTOR(3 DOWNTO 0);
    NET_MI_DRD : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
    NET_MI_ARDY : IN STD_LOGIC;
    NET_MI_DRDY : IN STD_LOGIC;
    USER_MI_DWR : OUT STD_LOGIC_VECTOR(31 DOWNTO 0);
    USER_MI_ADDR : OUT STD_LOGIC_VECTOR(31 DOWNTO 0);
    USER_MI_RD : OUT STD_LOGIC;
    USER_MI_WR : OUT STD_LOGIC;
    USER_MI_BE : OUT STD_LOGIC_VECTOR(3 DOWNTO 0);
    USER_MI_DRD : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
    USER_MI_ARDY : IN STD_LOGIC;
    USER_MI_DRDY : IN STD_LOGIC
  );
END design_1_host_int_0_0;

ARCHITECTURE design_1_host_int_0_0_arch OF design_1_host_int_0_0 IS
  ATTRIBUTE DowngradeIPIdentifiedWarnings : string;
  ATTRIBUTE DowngradeIPIdentifiedWarnings OF design_1_host_int_0_0_arch: ARCHITECTURE IS "yes";

  COMPONENT host_int IS
    GENERIC (
      USER_CLK_DIV : INTEGER;
      PROJECT_TEXT : STD_LOGIC_VECTOR(255 DOWNTO 0);
      SEPARATE_HEADER_IFC : BOOLEAN;
      HDR_WIDTH : INTEGER
    );
    PORT (
      PCIE0_SYS_CLK_P : IN STD_LOGIC;
      PCIE0_SYS_CLK_N : IN STD_LOGIC;
      PCIE1_SYS_CLK_P : IN STD_LOGIC;
      PCIE1_SYS_CLK_N : IN STD_LOGIC;
      PCIE_SYS_RESET_N : IN STD_LOGIC;
      PCI0_EXP_RXP : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
      PCI0_EXP_RXN : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
      PCI0_EXP_TXP : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
      PCI0_EXP_TXN : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
      PCI1_EXP_RXP : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
      PCI1_EXP_RXN : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
      PCI1_EXP_TXP : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
      PCI1_EXP_TXN : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
      CLK125_P : IN STD_LOGIC;
      CLK125_N : IN STD_LOGIC;
      BF_CLK : OUT STD_LOGIC;
      BF_NSS : OUT STD_LOGIC;
      BF_MOSI : OUT STD_LOGIC;
      BF_MISO : IN STD_LOGIC;
      DRPCLK : OUT STD_LOGIC;
      RESET : OUT STD_LOGIC;
      USER_CLK : OUT STD_LOGIC;
      USER_RESET : OUT STD_LOGIC;
      RX_DATA : IN STD_LOGIC_VECTOR(511 DOWNTO 0);
      RX_SOP_POS : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
      RX_EOP_POS : IN STD_LOGIC_VECTOR(5 DOWNTO 0);
      RX_SOP : IN STD_LOGIC;
      RX_EOP : IN STD_LOGIC;
      RX_SRC_RDY : IN STD_LOGIC;
      RX_DST_RDY : OUT STD_LOGIC;
      RX_HDATA : IN STD_LOGIC_VECTOR(127 DOWNTO 0);
      RX_HSOP_N : IN STD_LOGIC;
      RX_HEOP_N : IN STD_LOGIC;
      RX_HREM : IN STD_LOGIC_VECTOR(3 DOWNTO 0);
      RX_HSRC_RDY_N : IN STD_LOGIC;
      RX_HDST_RDY_N : OUT STD_LOGIC;
      TX_DATA : OUT STD_LOGIC_VECTOR(511 DOWNTO 0);
      TX_SOP_POS : OUT STD_LOGIC_VECTOR(2 DOWNTO 0);
      TX_EOP_POS : OUT STD_LOGIC_VECTOR(5 DOWNTO 0);
      TX_SOP : OUT STD_LOGIC;
      TX_EOP : OUT STD_LOGIC;
      TX_SRC_RDY : OUT STD_LOGIC;
      TX_DST_RDY : IN STD_LOGIC;
      MI_CLK : OUT STD_LOGIC;
      MI_RESET : OUT STD_LOGIC;
      ETH_MI_DWR : OUT STD_LOGIC_VECTOR(31 DOWNTO 0);
      ETH_MI_ADDR : OUT STD_LOGIC_VECTOR(31 DOWNTO 0);
      ETH_MI_RD : OUT STD_LOGIC;
      ETH_MI_WR : OUT STD_LOGIC;
      ETH_MI_BE : OUT STD_LOGIC_VECTOR(3 DOWNTO 0);
      ETH_MI_DRD : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
      ETH_MI_ARDY : IN STD_LOGIC;
      ETH_MI_DRDY : IN STD_LOGIC;
      NET_MI_DWR : OUT STD_LOGIC_VECTOR(31 DOWNTO 0);
      NET_MI_ADDR : OUT STD_LOGIC_VECTOR(31 DOWNTO 0);
      NET_MI_RD : OUT STD_LOGIC;
      NET_MI_WR : OUT STD_LOGIC;
      NET_MI_BE : OUT STD_LOGIC_VECTOR(3 DOWNTO 0);
      NET_MI_DRD : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
      NET_MI_ARDY : IN STD_LOGIC;
      NET_MI_DRDY : IN STD_LOGIC;
      USER_MI_DWR : OUT STD_LOGIC_VECTOR(31 DOWNTO 0);
      USER_MI_ADDR : OUT STD_LOGIC_VECTOR(31 DOWNTO 0);
      USER_MI_RD : OUT STD_LOGIC;
      USER_MI_WR : OUT STD_LOGIC;
      USER_MI_BE : OUT STD_LOGIC_VECTOR(3 DOWNTO 0);
      USER_MI_DRD : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
      USER_MI_ARDY : IN STD_LOGIC;
      USER_MI_DRDY : IN STD_LOGIC
    );
  END COMPONENT host_int;
  ATTRIBUTE X_INTERFACE_INFO : STRING;
  ATTRIBUTE X_INTERFACE_INFO OF PCIE0_SYS_CLK_P: SIGNAL IS "xilinx.com:interface:diff_clock:1.0 pcie0_clk CLK_P";
  ATTRIBUTE X_INTERFACE_INFO OF PCIE0_SYS_CLK_N: SIGNAL IS "xilinx.com:interface:diff_clock:1.0 pcie0_clk CLK_N";
  ATTRIBUTE X_INTERFACE_INFO OF PCIE1_SYS_CLK_P: SIGNAL IS "xilinx.com:interface:diff_clock:1.0 pcie1_clk CLK_P";
  ATTRIBUTE X_INTERFACE_INFO OF PCIE1_SYS_CLK_N: SIGNAL IS "xilinx.com:interface:diff_clock:1.0 pcie1_clk CLK_N";
  ATTRIBUTE X_INTERFACE_INFO OF PCI1_EXP_RXP: SIGNAL IS "cesnet:interface:pcie_diff_data_x8:1.0 pcie1_data_x8 RX_P";
  ATTRIBUTE X_INTERFACE_INFO OF PCI1_EXP_RXN: SIGNAL IS "cesnet:interface:pcie_diff_data_x8:1.0 pcie1_data_x8 RX_N";
  ATTRIBUTE X_INTERFACE_INFO OF PCI1_EXP_TXP: SIGNAL IS "cesnet:interface:pcie_diff_data_x8:1.0 pcie1_data_x8 TX_P";
  ATTRIBUTE X_INTERFACE_INFO OF PCI1_EXP_TXN: SIGNAL IS "cesnet:interface:pcie_diff_data_x8:1.0 pcie1_data_x8 TX_N";
  ATTRIBUTE X_INTERFACE_INFO OF CLK125_P: SIGNAL IS "xilinx.com:interface:diff_clock:1.0 clk_125 CLK_P";
  ATTRIBUTE X_INTERFACE_INFO OF CLK125_N: SIGNAL IS "xilinx.com:interface:diff_clock:1.0 clk_125 CLK_N";
  ATTRIBUTE X_INTERFACE_INFO OF BF_CLK: SIGNAL IS "cesnet:interface:bootfpga:1.0 bootfpga CLK";
  ATTRIBUTE X_INTERFACE_INFO OF BF_NSS: SIGNAL IS "cesnet:interface:bootfpga:1.0 bootfpga NSS";
  ATTRIBUTE X_INTERFACE_INFO OF BF_MOSI: SIGNAL IS "cesnet:interface:bootfpga:1.0 bootfpga MOSI";
  ATTRIBUTE X_INTERFACE_INFO OF BF_MISO: SIGNAL IS "cesnet:interface:bootfpga:1.0 bootfpga MISO";
  ATTRIBUTE X_INTERFACE_INFO OF RX_DATA: SIGNAL IS "cesnet:interface:flu:1.0 rx_flu DATA";
  ATTRIBUTE X_INTERFACE_INFO OF RX_SOP_POS: SIGNAL IS "cesnet:interface:flu:1.0 rx_flu SOP_POS";
  ATTRIBUTE X_INTERFACE_INFO OF RX_EOP_POS: SIGNAL IS "cesnet:interface:flu:1.0 rx_flu EOP_POS";
  ATTRIBUTE X_INTERFACE_INFO OF RX_SOP: SIGNAL IS "cesnet:interface:flu:1.0 rx_flu SOP";
  ATTRIBUTE X_INTERFACE_INFO OF RX_EOP: SIGNAL IS "cesnet:interface:flu:1.0 rx_flu EOP";
  ATTRIBUTE X_INTERFACE_INFO OF RX_SRC_RDY: SIGNAL IS "cesnet:interface:flu:1.0 rx_flu SRC_RDY";
  ATTRIBUTE X_INTERFACE_INFO OF RX_DST_RDY: SIGNAL IS "cesnet:interface:flu:1.0 rx_flu DST_RDY";
  ATTRIBUTE X_INTERFACE_INFO OF TX_DATA: SIGNAL IS "cesnet:interface:flu:1.0 tx_flu DATA";
  ATTRIBUTE X_INTERFACE_INFO OF TX_SOP_POS: SIGNAL IS "cesnet:interface:flu:1.0 tx_flu SOP_POS";
  ATTRIBUTE X_INTERFACE_INFO OF TX_EOP_POS: SIGNAL IS "cesnet:interface:flu:1.0 tx_flu EOP_POS";
  ATTRIBUTE X_INTERFACE_INFO OF TX_SOP: SIGNAL IS "cesnet:interface:flu:1.0 tx_flu SOP";
  ATTRIBUTE X_INTERFACE_INFO OF TX_EOP: SIGNAL IS "cesnet:interface:flu:1.0 tx_flu EOP";
  ATTRIBUTE X_INTERFACE_INFO OF TX_SRC_RDY: SIGNAL IS "cesnet:interface:flu:1.0 tx_flu SRC_RDY";
  ATTRIBUTE X_INTERFACE_INFO OF TX_DST_RDY: SIGNAL IS "cesnet:interface:flu:1.0 tx_flu DST_RDY";
  ATTRIBUTE X_INTERFACE_INFO OF ETH_MI_DWR: SIGNAL IS "cesnet:interface:mi_int:1.0 eth_mi MI_DWR";
  ATTRIBUTE X_INTERFACE_INFO OF ETH_MI_ADDR: SIGNAL IS "cesnet:interface:mi_int:1.0 eth_mi MI_ADDR";
  ATTRIBUTE X_INTERFACE_INFO OF ETH_MI_RD: SIGNAL IS "cesnet:interface:mi_int:1.0 eth_mi MI_RD";
  ATTRIBUTE X_INTERFACE_INFO OF ETH_MI_WR: SIGNAL IS "cesnet:interface:mi_int:1.0 eth_mi MI_WR";
  ATTRIBUTE X_INTERFACE_INFO OF ETH_MI_BE: SIGNAL IS "cesnet:interface:mi_int:1.0 eth_mi MI_BE";
  ATTRIBUTE X_INTERFACE_INFO OF ETH_MI_DRD: SIGNAL IS "cesnet:interface:mi_int:1.0 eth_mi MI_DRD";
  ATTRIBUTE X_INTERFACE_INFO OF ETH_MI_ARDY: SIGNAL IS "cesnet:interface:mi_int:1.0 eth_mi MI_ARDY";
  ATTRIBUTE X_INTERFACE_INFO OF ETH_MI_DRDY: SIGNAL IS "cesnet:interface:mi_int:1.0 eth_mi MI_DRDY";
  ATTRIBUTE X_INTERFACE_INFO OF NET_MI_DWR: SIGNAL IS "cesnet:interface:mi_int:1.0 net_mi MI_DWR";
  ATTRIBUTE X_INTERFACE_INFO OF NET_MI_ADDR: SIGNAL IS "cesnet:interface:mi_int:1.0 net_mi MI_ADDR";
  ATTRIBUTE X_INTERFACE_INFO OF NET_MI_RD: SIGNAL IS "cesnet:interface:mi_int:1.0 net_mi MI_RD";
  ATTRIBUTE X_INTERFACE_INFO OF NET_MI_WR: SIGNAL IS "cesnet:interface:mi_int:1.0 net_mi MI_WR";
  ATTRIBUTE X_INTERFACE_INFO OF NET_MI_BE: SIGNAL IS "cesnet:interface:mi_int:1.0 net_mi MI_BE";
  ATTRIBUTE X_INTERFACE_INFO OF NET_MI_DRD: SIGNAL IS "cesnet:interface:mi_int:1.0 net_mi MI_DRD";
  ATTRIBUTE X_INTERFACE_INFO OF NET_MI_ARDY: SIGNAL IS "cesnet:interface:mi_int:1.0 net_mi MI_ARDY";
  ATTRIBUTE X_INTERFACE_INFO OF NET_MI_DRDY: SIGNAL IS "cesnet:interface:mi_int:1.0 net_mi MI_DRDY";
  ATTRIBUTE X_INTERFACE_INFO OF USER_MI_DWR: SIGNAL IS "cesnet:interface:mi_int:1.0 user_mi MI_DWR";
  ATTRIBUTE X_INTERFACE_INFO OF USER_MI_ADDR: SIGNAL IS "cesnet:interface:mi_int:1.0 user_mi MI_ADDR";
  ATTRIBUTE X_INTERFACE_INFO OF USER_MI_RD: SIGNAL IS "cesnet:interface:mi_int:1.0 user_mi MI_RD";
  ATTRIBUTE X_INTERFACE_INFO OF USER_MI_WR: SIGNAL IS "cesnet:interface:mi_int:1.0 user_mi MI_WR";
  ATTRIBUTE X_INTERFACE_INFO OF USER_MI_BE: SIGNAL IS "cesnet:interface:mi_int:1.0 user_mi MI_BE";
  ATTRIBUTE X_INTERFACE_INFO OF USER_MI_DRD: SIGNAL IS "cesnet:interface:mi_int:1.0 user_mi MI_DRD";
  ATTRIBUTE X_INTERFACE_INFO OF USER_MI_ARDY: SIGNAL IS "cesnet:interface:mi_int:1.0 user_mi MI_ARDY";
  ATTRIBUTE X_INTERFACE_INFO OF USER_MI_DRDY: SIGNAL IS "cesnet:interface:mi_int:1.0 user_mi MI_DRDY";
BEGIN
  U0 : host_int
    GENERIC MAP (
      USER_CLK_DIV => 14,
      PROJECT_TEXT => X"313030475F4E4943000000000000000000000000000000000000000000000000",
      SEPARATE_HEADER_IFC => false,
      HDR_WIDTH => 128
    )
    PORT MAP (
      PCIE0_SYS_CLK_P => PCIE0_SYS_CLK_P,
      PCIE0_SYS_CLK_N => PCIE0_SYS_CLK_N,
      PCIE1_SYS_CLK_P => PCIE1_SYS_CLK_P,
      PCIE1_SYS_CLK_N => PCIE1_SYS_CLK_N,
      PCIE_SYS_RESET_N => PCIE_SYS_RESET_N,
      PCI0_EXP_RXP => STD_LOGIC_VECTOR(TO_UNSIGNED(0, 8)),
      PCI0_EXP_RXN => STD_LOGIC_VECTOR(TO_UNSIGNED(0, 8)),
      PCI1_EXP_RXP => PCI1_EXP_RXP,
      PCI1_EXP_RXN => PCI1_EXP_RXN,
      PCI1_EXP_TXP => PCI1_EXP_TXP,
      PCI1_EXP_TXN => PCI1_EXP_TXN,
      CLK125_P => CLK125_P,
      CLK125_N => CLK125_N,
      BF_CLK => BF_CLK,
      BF_NSS => BF_NSS,
      BF_MOSI => BF_MOSI,
      BF_MISO => BF_MISO,
      DRPCLK => DRPCLK,
      RESET => RESET,
      USER_CLK => USER_CLK,
      USER_RESET => USER_RESET,
      RX_DATA => RX_DATA,
      RX_SOP_POS => RX_SOP_POS,
      RX_EOP_POS => RX_EOP_POS,
      RX_SOP => RX_SOP,
      RX_EOP => RX_EOP,
      RX_SRC_RDY => RX_SRC_RDY,
      RX_DST_RDY => RX_DST_RDY,
      RX_HDATA => STD_LOGIC_VECTOR(TO_UNSIGNED(0, 128)),
      RX_HSOP_N => '0',
      RX_HEOP_N => '0',
      RX_HREM => STD_LOGIC_VECTOR(TO_UNSIGNED(0, 4)),
      RX_HSRC_RDY_N => '0',
      TX_DATA => TX_DATA,
      TX_SOP_POS => TX_SOP_POS,
      TX_EOP_POS => TX_EOP_POS,
      TX_SOP => TX_SOP,
      TX_EOP => TX_EOP,
      TX_SRC_RDY => TX_SRC_RDY,
      TX_DST_RDY => TX_DST_RDY,
      MI_CLK => MI_CLK,
      MI_RESET => MI_RESET,
      ETH_MI_DWR => ETH_MI_DWR,
      ETH_MI_ADDR => ETH_MI_ADDR,
      ETH_MI_RD => ETH_MI_RD,
      ETH_MI_WR => ETH_MI_WR,
      ETH_MI_BE => ETH_MI_BE,
      ETH_MI_DRD => ETH_MI_DRD,
      ETH_MI_ARDY => ETH_MI_ARDY,
      ETH_MI_DRDY => ETH_MI_DRDY,
      NET_MI_DWR => NET_MI_DWR,
      NET_MI_ADDR => NET_MI_ADDR,
      NET_MI_RD => NET_MI_RD,
      NET_MI_WR => NET_MI_WR,
      NET_MI_BE => NET_MI_BE,
      NET_MI_DRD => NET_MI_DRD,
      NET_MI_ARDY => NET_MI_ARDY,
      NET_MI_DRDY => NET_MI_DRDY,
      USER_MI_DWR => USER_MI_DWR,
      USER_MI_ADDR => USER_MI_ADDR,
      USER_MI_RD => USER_MI_RD,
      USER_MI_WR => USER_MI_WR,
      USER_MI_BE => USER_MI_BE,
      USER_MI_DRD => USER_MI_DRD,
      USER_MI_ARDY => USER_MI_ARDY,
      USER_MI_DRDY => USER_MI_DRDY
    );
END design_1_host_int_0_0_arch;
