----------------------------------------------------
--  
--      VHDL code generated by Visual Elite
--
--  Design Unit:
--  ------------
--      Unit    Name  :  Encode
--      Library Name  :  PCS_verilog
--  
--      Creation Date :  Tue Jul 13 15:25:54 2004
--      Version       :  3.5.1 build 43. Date: Feb 22 2004. License: 2004.2
--  
--  Options Used:
--  -------------
--      Target
--         Language   :  VHDL
--         Purpose    :  Synthesis
--         Vendor     :  Design Compiler
--  
--      Style
--         Use tasks                      :  No
--         Code Destination               :  1 File per Unit
--         Attach Packages                :  No
--         Generate Entity                :  Yes
--         Attach Directives              :  Yes
--         Structural                     :  No
--         Preserve spacing for free text :  Yes
--         Declaration alignment          :  No
--
----------------------------------------------------
----------------------------------------------------
--  
--  Library Name :  PCS_verilog
--  Unit    Name :  Encode
--  Unit    Type :  Text Unit
--  
------------------------------------------------------
 
-- ---------------- Xilinx, CTD Systems & Apps  ------------------------
--  FileName: Encode.v
--  Begin Date: Fri Jun 18 15:36:32 2004
--  Description:
--   Disclaimer: LIMITED WARRANTY AND DISCLAMER. These designs are
--               provided to you "as is". Xilinx and its licensors make, and you
--               receive no warranties or conditions, express, implied,
--               statutory or otherwise, and Xilinx specifically disclaims any
--               implied warranties of merchantability, non-infringement, or
--               fitness for a particular purpose. Xilinx does not warrant that
--               the functions contained in these designs will meet your
--               requirements, or that the operation of these designs will be
--               uninterrupted or error free, or that defects in the Designs
--               will be corrected. Furthermore, Xilinx does not warrant or
--               make any representations regarding use or the results of the
--               use of the designs in terms of correctness, accuracy,
--               reliability, or otherwise.
--               LIMITATION OF LIABILITY. In no event will Xilinx or its
--               licensors be liable for any loss of data, lost profits, cost
--               or procurement of substitute goods or services, or for any
--               special, incidental, consequential, or indirect damages
--               arising from the use or operation of the designs or
--               accompanying documentation, however caused and on any theory
--               of liability. This limitation will apply even if Xilinx
--               has been advised of the possibility of such damage. This
--               limitation shall apply not-withstanding the failure of the
--               essential purpose of any limited remedies herein.
--   Copyright  2002 Xilinx, Inc.
--   All rights reserved
--                        Revision History
-- -----------------------------------------------------------------
--  Date Modified             User Name            Full Name
--         Descrition of Changes
-- -----------------------------------------------------------------
--  $Log$
-- -----------------------------------------------------------------
--  NOTES:
-- -----------------------------------------------------------------
-- -----------------------------------------------------------------

--library SYNOPSYS;
--use SYNOPSYS.ATTRIBUTES.ALL;
 
 
library ieee;
use ieee.STD_LOGIC_1164.all;
use ieee.STD_LOGIC_ARITH.all;
use ieee.STD_LOGIC_MISC.all;
use ieee.STD_LOGIC_UNSIGNED.all;
 
 
entity Encode is
  port (
        bypass_66encoder : in STD_LOGIC;
        clk156 : in STD_LOGIC;
        rstb : in STD_LOGIC;
        txcontrol : in STD_LOGIC_VECTOR(7 downto 0 );
        txdata : in STD_LOGIC_VECTOR(63 downto 0 );
        TXD_encoded : out STD_LOGIC_VECTOR(65 downto 0 );
        TX_STATE      : out std_logic_vector(2 downto 0);
        TX_STATE_PREV : in std_logic_vector(2 downto 0);
        txlf : out STD_LOGIC
        );
end Encode;


architecture Encode of Encode is

  component T_TYPE_Encode
      port (
            clk156 : in STD_LOGIC := 'Z';
            rstb : in STD_LOGIC := 'Z';
            coded_vec : out STD_LOGIC_VECTOR(65 downto 0 );
            txdata : in STD_LOGIC_VECTOR(63 downto 0 ) :=
            "ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ";
            txcontrol : in STD_LOGIC_VECTOR(7 downto 0 ) := "ZZZZZZZZ";
            T_TYPE : out STD_LOGIC_VECTOR(2 downto 0 )
            );
  end component;
  component TX_FSM
      port (
            clk156 : in STD_LOGIC := 'Z';
            rstb : in STD_LOGIC := 'Z';
            T_TYPE : in STD_LOGIC_VECTOR(2 downto 0 ) := "ZZZ";
            coded_vec : in STD_LOGIC_VECTOR(65 downto 0 ) :=
            "ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ";
            txdata : in STD_LOGIC_VECTOR (63 downto 0) :=
            "ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ";
            bypass_66encoder : in STD_LOGIC := 'Z';
            TXD_encoded : out STD_LOGIC_VECTOR(65 downto 0 );
            STATE_PREV : in STD_LOGIC_VECTOR(2 downto 0 ); -- State of previos lane
            STATE      : out STD_LOGIC_VECTOR(2 downto 0 ); -- State of current lane
            txlf : out STD_LOGIC
            );
  end component;
  --   local signals
  signal LF_init_state : STD_LOGIC;
  signal T_TYPE : STD_LOGIC_VECTOR(2 downto 0 );
  signal coded_vec : STD_LOGIC_VECTOR(65 downto 0 );
begin
 
 
  visual_0_T_TYPE_Encode: T_TYPE_Encode
    port map (
              clk156 => clk156,
              rstb => rstb,
              txdata => txdata(63 downto 0),
              txcontrol => txcontrol(7 downto 0),
              coded_vec => coded_vec(65 downto 0),
              T_TYPE => T_TYPE(2 downto 0)
              );
 
  --   input ports
  --   output ports
  visual_0_TX_FSM: TX_FSM
    port map (
              clk156 => clk156,
              rstb => rstb,
              T_TYPE => T_TYPE(2 downto 0),
              coded_vec => coded_vec(65 downto 0),
              txdata => txdata(63 downto 0),
              bypass_66encoder => bypass_66encoder,
              TXD_encoded => TXD_encoded(65 downto 0),
              STATE_PREV => TX_STATE_PREV,
              STATE      => TX_STATE,
              txlf => txlf
              );
  --   input ports
  --   output ports
 
end ;

