///////////////////////////////////////////////////////////////////////////////
//   ____  ____ 
//  /   /\/   /
// /___/  \  /    Vendor: Xilinx
// \   \   \/     Version : 3.2
//  \   \         Application : 7 Series FPGAs Transceivers Wizard
//  /   /         Filename : gtz_caui4_multi_gt.v
// /___/   /\     
// \   \  /  \ 
//  \___\/\___\
//
//
// Module gtz_caui4_multi_gt (a Multi GT Wrapper)
// Generated by Xilinx 7 Series FPGAs Transceivers Wizard
// 
// 
// (c) Copyright 2010-2012 Xilinx, Inc. All rights reserved.
// 
// This file contains confidential and proprietary information
// of Xilinx, Inc. and is protected under U.S. and
// international copyright and other intellectual property
// laws.
// 
// DISCLAIMER
// This disclaimer is not a license and does not grant any
// rights to the materials distributed herewith. Except as
// otherwise provided in a valid license issued to you by
// Xilinx, and to the maximum extent permitted by applicable
// law: (1) THESE MATERIALS ARE MADE AVAILABLE "AS IS" AND
// WITH ALL FAULTS, AND XILINX HEREBY DISCLAIMS ALL WARRANTIES
// AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY, INCLUDING
// BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-
// INFRINGEMENT, OR FITNESS FOR ANY PARTICULAR PURPOSE; and
// (2) Xilinx shall not be liable (whether in contract or tort,
// including negligence, or under any other theory of
// liability) for any loss or damage of any kind or nature
// related to, arising under or in connection with these
// materials, including for any direct, or any indirect,
// special, incidental, or consequential loss or damage
// (including loss of data, profits, goodwill, or any type of
// loss or damage suffered as a result of any action brought
// by a third party) even if such damage or loss was
// reasonably foreseeable or Xilinx had been advised of the
// possibility of the same.
// 
// CRITICAL APPLICATIONS
// Xilinx products are not designed or intended to be fail-
// safe, or for use in any application requiring fail-safe
// performance, such as life-support or safety devices or
// systems, Class III medical devices, nuclear facilities,
// applications related to the deployment of airbags, or any
// other applications that could lead to death, personal
// injury, or severe property or environmental damage
// (individually and collectively, "Critical
// Applications"). Customer assumes the sole risk and
// liability of any use of Xilinx products in Critical
// Applications, subject only to applicable laws and
// regulations governing limitations on product liability.
// 
// THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS
// PART OF THIS FILE AT ALL TIMES. 


`default_nettype wire

`timescale 1ns / 1ps
`define DLY #1

//***************************** Entity Declaration ****************************

(* CORE_GENERATION_INFO = "gtz_caui4_multi_gt,gtwizard_v3_2,{protocol_file=Start_from_scratch}" *) module gtz_caui4_multi_gt #
(
    // Simulation attributes
    parameter   SIM_GTZRESET_SPEEDUP     =   "TRUE",       // Set to 1 to speed up sim reset;
    parameter   SIM_VERSION              =  "1.0"
)
(

    input rxusrclk0_in,
    input rxusrclk1_in,
    input rxusrclk2_in,
    input rxusrclk3_in,
    input rxusrclk4_in,
    input rxusrclk5_in,
    input rxusrclk6_in,
    input rxusrclk7_in,

    input txusrclk0_in,
    input txusrclk1_in,
    input txusrclk2_in,
    input txusrclk3_in,
    input txusrclk4_in,
    input txusrclk5_in,
    input txusrclk6_in,
    input txusrclk7_in,

    input drpclk0_in,
    input drpclk1_in,
 
    //_________________________________________________________________________
    //----------------------- REFCLK Ports -------------------------------
    input oct0_gtrefclk0p_in,
    input oct0_gtrefclk0n_in,
    input oct0_gtrefclk1p_in,
    input oct0_gtrefclk1n_in,
    input oct0_drpclksel_in,
    
    output oct0_rxcoreclk0_out,
    output oct0_rxcoreclk1_out,
    output oct0_rxcoreclk2_out,
    output oct0_rxcoreclk3_out,
    output oct0_txcoreclk0_out,
    output oct0_txcoreclk1_out,
   
    //-------------------------------- Serial Ports ---------------------------------
    output oct0_gtztxp0_out,
    output oct0_gtztxn0_out,
    input oct0_gtzrxp0_in,
    input oct0_gtzrxn0_in,
    output oct0_gtztxp1_out,
    output oct0_gtztxn1_out,
    input oct0_gtzrxp1_in,
    input oct0_gtzrxn1_in,
    output oct0_gtztxp2_out,
    output oct0_gtztxn2_out,
    input oct0_gtzrxp2_in,
    input oct0_gtzrxn2_in,
    output oct0_gtztxp3_out,
    output oct0_gtztxn3_out,
    input oct0_gtzrxp3_in,
    input oct0_gtzrxn3_in,
    // ---------------------------- RX/TX polarity control -------------------
    input   [3:0]   oct0_gtzrxpolarity_in,
    input   [3:0]   oct0_gtztxpolarity_in,    
                      
    //----------------------------- BitSlip Ports ------------------------------
    input   [4:0]   oct0_rxgearboxslip0_in,
    input   [4:0]   oct0_rxgearboxslip1_in,
    input   [4:0]   oct0_rxgearboxslip2_in,
    input   [4:0]   oct0_rxgearboxslip3_in,
    //----------------------------- Clocking Ports -----------------------------
    input           oct0_refclksel0_in,
    input           oct0_refclksel1_in,
    input           oct0_refclksel2_in,
    input           oct0_refclksel3_in,
    output          oct0_rxoutclk0_out,
    output          oct0_rxoutclk1_out,
    output          oct0_rxoutclk2_out,
    output          oct0_rxoutclk3_out,
    output          oct0_txoutclk0_out,
    output          oct0_txoutclk1_out,
    //-------------------------- Configuration Ports ---------------------------
    input           oct0_gtzinit_in,
    output          oct0_gtzinitdoneb_out,
    input           oct0_pllrecalen0_in,
    input           oct0_pllrecalen1_in,
    input           oct0_pllrecalen2_in,
    input           oct0_pllrecalen3_in,    
    input           oct0_txen0_in,    
    input           oct0_txen1_in,    
    input           oct0_txen2_in,    
    input           oct0_txen3_in,
    input           oct0_rxen0_in,    
    input           oct0_rxen1_in,    
    input           oct0_rxen2_in,    
    input           oct0_rxen3_in,    
    //------------------------------- DRP Ports --------------------------------
    input   [15:0]  oct0_drpaddr_in,
    input   [31:0]  oct0_drpdi_in,
    output  [31:0]  oct0_drpdo_out,
    input           oct0_drpen_in,
    output          oct0_drprdy_out,
    output  [2:0]   oct0_drpstatus_out,
    output          oct0_drpwdterr_out,
    input           oct0_drpwe_in,
    //---------------------------- FIB Reset Ports -----------------------------
    input           oct0_rxfibreset0_in,
    input           oct0_rxfibreset1_in,
    input           oct0_rxfibreset2_in,
    input           oct0_rxfibreset3_in,
    //-------------------------- Latency clock Ports ---------------------------
    input           oct0_rxlatclk_in,
    input           oct0_txlatclk_in,
    //------------------------------- Loopbacks --------------------------------
    input           oct0_nearloopbacken0_in,
    input           oct0_nearloopbacken1_in,
    input           oct0_nearloopbacken2_in,
    input           oct0_nearloopbacken3_in,
    //-------------------------- Rx Fabric Interface ---------------------------
    output  [159:0] oct0_rxdata0_out,
    output  [159:0] oct0_rxdata1_out,
    output  [159:0] oct0_rxdata2_out,
    output  [159:0] oct0_rxdata3_out,
    output  [4:0]   oct0_rxdatavalid0_out,
    output  [4:0]   oct0_rxdatavalid1_out,
    output  [4:0]   oct0_rxdatavalid2_out,
    output  [4:0]   oct0_rxdatavalid3_out,
    output  [9:0]   oct0_rxheader0_out,
    output  [9:0]   oct0_rxheader1_out,
    output  [9:0]   oct0_rxheader2_out,
    output  [9:0]   oct0_rxheader3_out,
    output  [4:0]   oct0_rxheadervalid0_out,
    output  [4:0]   oct0_rxheadervalid1_out,
    output  [4:0]   oct0_rxheadervalid2_out,
    output  [4:0]   oct0_rxheadervalid3_out,
    //-------------------------- Rx Reset Controller ---------------------------
    input           oct0_gtzrxreset0_in,
    input           oct0_gtzrxreset1_in,
    input           oct0_gtzrxreset2_in,
    input           oct0_gtzrxreset3_in,
    output          oct0_rxrdy0_out,
    output          oct0_rxrdy1_out,
    output          oct0_rxrdy2_out,
    output          oct0_rxrdy3_out,
    output          oct0_rxresetdone0_out,
    output          oct0_rxresetdone1_out,
    output          oct0_rxresetdone2_out,
    output          oct0_rxresetdone3_out,
    //-------------------------- Tx Fabric Interface ---------------------------
    input   [159:0] oct0_txdata0_in,
    input   [159:0] oct0_txdata1_in,
    input   [159:0] oct0_txdata2_in,
    input   [159:0] oct0_txdata3_in,
    input   [9:0]   oct0_txheader0_in,
    input   [9:0]   oct0_txheader1_in,
    input   [9:0]   oct0_txheader2_in,
    input   [9:0]   oct0_txheader3_in,
    //-------------------------- Tx Reset Controller ---------------------------
    input           oct0_gtztxreset0_in,
    input           oct0_gtztxreset1_in,
    input           oct0_gtztxreset2_in,
    input           oct0_gtztxreset3_in,
    output          oct0_txrdy0_out,
    output          oct0_txrdy1_out,
    output          oct0_txrdy2_out,
    output          oct0_txrdy3_out,
    output          oct0_txresetdone0_out,
    output          oct0_txresetdone1_out,
    output          oct0_txresetdone2_out,
    output          oct0_txresetdone3_out,
    //--------------------------- Tx sequence Ports ----------------------------
    input   [6:0]   oct0_txsequence0_in,
    input   [6:0]   oct0_txsequence1_in,
    input   [6:0]   oct0_txsequence2_in,
    input   [6:0]   oct0_txsequence3_in


     );

              
    gtz_caui4_OCTAL0 #
    (
        // Simulation attributes
        .SIM_GTZRESET_SPEEDUP   (SIM_GTZRESET_SPEEDUP),
        //pragma translate_off
        .RXUSRCLK_LANE0_VAR     ("RXUSRCLK1"),
        .RXUSRCLK_LANE1_VAR     ("RXUSRCLK1"),
        .RXUSRCLK_LANE2_VAR     ("RXUSRCLK1"),
        .RXUSRCLK_LANE3_VAR     ("RXUSRCLK1"),
        .RXUSRCLK_LANE4_VAR     ("RXUSRCLK0"),
        .RXUSRCLK_LANE5_VAR     ("RXUSRCLK0"),
        .RXUSRCLK_LANE6_VAR     ("RXUSRCLK0"),
        .RXUSRCLK_LANE7_VAR     ("RXUSRCLK0"),
        .TXUSRCLK_LANE0_VAR     ("TXUSRCLK0"),
        .TXUSRCLK_LANE1_VAR     ("TXUSRCLK0"),
        .TXUSRCLK_LANE2_VAR     ("TXUSRCLK0"),
        .TXUSRCLK_LANE3_VAR     ("TXUSRCLK0"),
        .TXUSRCLK_LANE4_VAR     ("TXUSRCLK0"),
        .TXUSRCLK_LANE5_VAR     ("TXUSRCLK0"),
        .TXUSRCLK_LANE6_VAR     ("TXUSRCLK0"),
        .TXUSRCLK_LANE7_VAR     ("TXUSRCLK0"),
        //pragma translate_on
        .SIM_VERSION       (SIM_VERSION) 
    )
    octal0_gtz_caui4_i
    (

         //----------------------- REFCLK Ports -------------------------------
	      .gtrefclk0p_in                   (oct0_gtrefclk0p_in),
	      .gtrefclk0n_in                   (oct0_gtrefclk0n_in),
	      .gtrefclk1p_in                   (oct0_gtrefclk1p_in),
	      .gtrefclk1n_in                   (oct0_gtrefclk1n_in),
	      .drpclksel_in                    (oct0_drpclksel_in),

        //-----------------------User clocks--------------------------
        .rxcoreclk0_out                  (oct0_rxcoreclk0_out),
        .rxcoreclk1_out                  (oct0_rxcoreclk1_out),
        .rxcoreclk2_out                  (oct0_rxcoreclk2_out),
        .rxcoreclk3_out                  (oct0_rxcoreclk3_out),
        .txcoreclk0_out                  (oct0_txcoreclk0_out),
        .txcoreclk1_out                  (oct0_txcoreclk1_out),

        .rxusrclk0_in                    (rxusrclk0_in),
        .rxusrclk1_in                    (rxusrclk1_in),
        .rxusrclk2_in                    (rxusrclk2_in),
        .rxusrclk3_in                    (rxusrclk3_in),
        .rxusrclk4_in                    (rxusrclk4_in),
        .rxusrclk5_in                    (rxusrclk5_in),
        .rxusrclk6_in                    (rxusrclk6_in),
        .rxusrclk7_in                    (rxusrclk7_in),

        .txusrclk0_in                    (txusrclk0_in),
        .txusrclk1_in                    (txusrclk1_in),
        .txusrclk2_in                    (txusrclk2_in),
        .txusrclk3_in                    (txusrclk3_in),
        .txusrclk4_in                    (txusrclk4_in),
        .txusrclk5_in                    (txusrclk5_in),
        .txusrclk6_in                    (txusrclk6_in),
        .txusrclk7_in                    (txusrclk7_in),

	     .drpclk0_in                      (drpclk0_in),
        .drpclk1_in                      (drpclk1_in),	

    //-------------------------------- Serial Ports ---------------------------------
        .gtztxp0_out               (oct0_gtztxp0_out),
        .gtztxn0_out               (oct0_gtztxn0_out),
        .gtzrxp0_in                (oct0_gtzrxp0_in),
        .gtzrxn0_in                (oct0_gtzrxn0_in),
        .gtztxp1_out               (oct0_gtztxp1_out),
        .gtztxn1_out               (oct0_gtztxn1_out),
        .gtzrxp1_in                (oct0_gtzrxp1_in),
        .gtzrxn1_in                (oct0_gtzrxn1_in),
        .gtztxp2_out               (oct0_gtztxp2_out),
        .gtztxn2_out               (oct0_gtztxn2_out),
        .gtzrxp2_in                (oct0_gtzrxp2_in),
        .gtzrxn2_in                (oct0_gtzrxn2_in),
        .gtztxp3_out               (oct0_gtztxp3_out),
        .gtztxn3_out               (oct0_gtztxn3_out),
        .gtzrxp3_in                (oct0_gtzrxp3_in),
        .gtzrxn3_in                (oct0_gtzrxn3_in),
        
        // ----------------------------- RX/TX polarity -------------------------------
        .oct0_gtzrxpolarity_in     (oct0_gtzrxpolarity_in),
        .oct0_gtztxpolarity_in     (oct0_gtztxpolarity_in),        
     
        //----------------------------- BitSlip Ports ------------------------------
        .rxgearboxslip0_in              (oct0_rxgearboxslip0_in),
        .rxgearboxslip1_in              (oct0_rxgearboxslip1_in),
        .rxgearboxslip2_in              (oct0_rxgearboxslip2_in),
        .rxgearboxslip3_in              (oct0_rxgearboxslip3_in),
        //----------------------------- Clocking Ports -----------------------------
        .refclksel0_in                  (oct0_refclksel0_in),
        .refclksel1_in                  (oct0_refclksel1_in),
        .refclksel2_in                  (oct0_refclksel2_in),
        .refclksel3_in                  (oct0_refclksel3_in),
        .rxoutclk0_out                  (oct0_rxoutclk0_out),
        .rxoutclk1_out                  (oct0_rxoutclk1_out),
        .rxoutclk2_out                  (oct0_rxoutclk2_out),
        .rxoutclk3_out                  (oct0_rxoutclk3_out),
        .txoutclk0_out                  (oct0_txoutclk0_out),
        .txoutclk1_out                  (oct0_txoutclk1_out),
        //-------------------------- Configuration Ports ---------------------------
        .gtzinit_in                     (oct0_gtzinit_in),
        .gtzinitdoneb_out               (oct0_gtzinitdoneb_out),
        .pllrecalen0_in                 (oct0_pllrecalen0_in),
        .pllrecalen1_in                 (oct0_pllrecalen1_in),
        .pllrecalen2_in                 (oct0_pllrecalen2_in),
        .pllrecalen3_in                 (oct0_pllrecalen3_in),
        .txen0_in                       (oct0_txen0_in),
        .txen1_in                       (oct0_txen1_in),
        .txen2_in                       (oct0_txen2_in),
        .txen3_in                       (oct0_txen3_in),
        .rxen0_in                       (oct0_rxen0_in),
        .rxen1_in                       (oct0_rxen1_in),
        .rxen2_in                       (oct0_rxen2_in),
        .rxen3_in                       (oct0_rxen3_in),
        //------------------------------- DRP Ports --------------------------------
        .drpaddr_in                     (oct0_drpaddr_in),
        .drpdi_in                       (oct0_drpdi_in),
        .drpdo_out                      (oct0_drpdo_out),
        .drpen_in                       (oct0_drpen_in),
        .drprdy_out                     (oct0_drprdy_out),
        .drpstatus_out                  (oct0_drpstatus_out),
        .drpwdterr_out                  (oct0_drpwdterr_out),
        .drpwe_in                       (oct0_drpwe_in),
        //---------------------------- FIB Reset Ports -----------------------------
        .rxfibreset0_in                 (oct0_rxfibreset0_in),
        .rxfibreset1_in                 (oct0_rxfibreset1_in),
        .rxfibreset2_in                 (oct0_rxfibreset2_in),
        .rxfibreset3_in                 (oct0_rxfibreset3_in),
        //-------------------------- Latency clock Ports ---------------------------
        .rxlatclk_in                    (oct0_rxlatclk_in),
        .txlatclk_in                    (oct0_txlatclk_in),
        //------------------------------- Loopbacks --------------------------------
        .nearloopbacken0_in             (oct0_nearloopbacken0_in),
        .nearloopbacken1_in             (oct0_nearloopbacken1_in),
        .nearloopbacken2_in             (oct0_nearloopbacken2_in),
        .nearloopbacken3_in             (oct0_nearloopbacken3_in),
        //-------------------------- Rx Fabric Interface ---------------------------
        .rxdata0_out                    (oct0_rxdata0_out),
        .rxdata1_out                    (oct0_rxdata1_out),
        .rxdata2_out                    (oct0_rxdata2_out),
        .rxdata3_out                    (oct0_rxdata3_out),
        .rxdatavalid0_out               (oct0_rxdatavalid0_out),
        .rxdatavalid1_out               (oct0_rxdatavalid1_out),
        .rxdatavalid2_out               (oct0_rxdatavalid2_out),
        .rxdatavalid3_out               (oct0_rxdatavalid3_out),
        .rxheader0_out                  (oct0_rxheader0_out),
        .rxheader1_out                  (oct0_rxheader1_out),
        .rxheader2_out                  (oct0_rxheader2_out),
        .rxheader3_out                  (oct0_rxheader3_out),
        .rxheadervalid0_out             (oct0_rxheadervalid0_out),
        .rxheadervalid1_out             (oct0_rxheadervalid1_out),
        .rxheadervalid2_out             (oct0_rxheadervalid2_out),
        .rxheadervalid3_out             (oct0_rxheadervalid3_out),
        //-------------------------- Rx Reset Controller ---------------------------
        .gtzrxreset0_in                 (oct0_gtzrxreset0_in),
        .gtzrxreset1_in                 (oct0_gtzrxreset1_in),
        .gtzrxreset2_in                 (oct0_gtzrxreset2_in),
        .gtzrxreset3_in                 (oct0_gtzrxreset3_in),
        .rxrdy0_out                     (oct0_rxrdy0_out),
        .rxrdy1_out                     (oct0_rxrdy1_out),
        .rxrdy2_out                     (oct0_rxrdy2_out),
        .rxrdy3_out                     (oct0_rxrdy3_out),
        .rxresetdone0_out               (oct0_rxresetdone0_out),
        .rxresetdone1_out               (oct0_rxresetdone1_out),
        .rxresetdone2_out               (oct0_rxresetdone2_out),
        .rxresetdone3_out               (oct0_rxresetdone3_out),
        //-------------------------- Tx Fabric Interface ---------------------------
        .txdata0_in                     (oct0_txdata0_in),
        .txdata1_in                     (oct0_txdata1_in),
        .txdata2_in                     (oct0_txdata2_in),
        .txdata3_in                     (oct0_txdata3_in),
        .txheader0_in                   (oct0_txheader0_in),
        .txheader1_in                   (oct0_txheader1_in),
        .txheader2_in                   (oct0_txheader2_in),
        .txheader3_in                   (oct0_txheader3_in),
        //-------------------------- Tx Reset Controller ---------------------------
        .gtztxreset0_in                 (oct0_gtztxreset0_in),
        .gtztxreset1_in                 (oct0_gtztxreset1_in),
        .gtztxreset2_in                 (oct0_gtztxreset2_in),
        .gtztxreset3_in                 (oct0_gtztxreset3_in),
        .txrdy0_out                     (oct0_txrdy0_out),
        .txrdy1_out                     (oct0_txrdy1_out),
        .txrdy2_out                     (oct0_txrdy2_out),
        .txrdy3_out                     (oct0_txrdy3_out),
        .txresetdone0_out               (oct0_txresetdone0_out),
        .txresetdone1_out               (oct0_txresetdone1_out),
        .txresetdone2_out               (oct0_txresetdone2_out),
        .txresetdone3_out               (oct0_txresetdone3_out),
        //--------------------------- Tx sequence Ports ----------------------------
        .txsequence0_in                 (oct0_txsequence0_in),
        .txsequence1_in                 (oct0_txsequence1_in),
        .txsequence2_in                 (oct0_txsequence2_in),
        .txsequence3_in                 (oct0_txsequence3_in)

     );
                      
endmodule

