----------------------------------------------------
--  
--      VHDL code generated by Visual Elite
--
--  Design Unit:
--  ------------
--      Unit    Name  :  Decode
--      Library Name  :  PCS_verilog
--  
--      Creation Date :  Tue Jul 13 11:21:47 2004
--      Version       :  3.5.1 build 43. Date: Feb 22 2004. License: 2004.2
--  
--  Options Used:
--  -------------
--      Target
--         Language   :  VHDL
--         Purpose    :  Synthesis
--         Vendor     :  Design Compiler
--  
--      Style
--         Use tasks                      :  No
--         Code Destination               :  1 File per Unit
--         Attach Packages                :  No
--         Generate Entity                :  Yes
--         Attach Directives              :  Yes
--         Structural                     :  No
--         Preserve spacing for free text :  Yes
--         Declaration alignment          :  No
--
----------------------------------------------------
----------------------------------------------------
--  
--  Library Name :  PCS_verilog
--  Unit    Name :  Decode
--  Unit    Type :  Text Unit
--  
------------------------------------------------------

-- ------------------------------------------------------------------------------
--  Xilinx Proprietary and Confidential
--  FileName: Decode.v
--
-- ------------------------------------------------------------------------------
 
--library SYNOPSYS;
--use SYNOPSYS.ATTRIBUTES.ALL;
 
 
library ieee;
use ieee.STD_LOGIC_1164.all;
use ieee.STD_LOGIC_ARITH.all;
use ieee.STD_LOGIC_MISC.all;
use ieee.STD_LOGIC_UNSIGNED.all;
 
 
entity Decode is
  generic (
        STATE_SIMPLIFIED : boolean := true
  );
  port (
        DeScr_RXD : in STD_LOGIC_VECTOR(65 downto 0 );
        blk_lock : in STD_LOGIC;
        bypass_66decoder : in STD_LOGIC;
        lpbk : in STD_LOGIC;
        clear_errblk : in STD_LOGIC;
        clk156 : in STD_LOGIC;
        hi_ber : in STD_LOGIC;
        rstb156 : in STD_LOGIC;
        rxlf : out STD_LOGIC;
        errd_blks : out STD_LOGIC_VECTOR(7 downto 0 );
        rxcontrol : out STD_LOGIC_VECTOR(7 downto 0 );
        rxdata : out STD_LOGIC_VECTOR(63 downto 0 );
        STATE_PREV : in STD_LOGIC_VECTOR(2 downto 0 );
        STATE      : out STD_LOGIC_VECTOR(2 downto 0 );
        DEC_ERROR  : out STD_LOGIC; -- Block decode error
        SEQ_ERROR  : out STD_LOGIC; -- Block sequencing error
        STATE_O    : out std_logic_vector(2 downto 0)
  );
end Decode;


architecture Decode of Decode is
 
  component R_TYPE_Decode
      port (
            rstb156 : in STD_LOGIC := 'Z';
            clk156 : in STD_LOGIC := 'Z';
            DeScr_RXD : in STD_LOGIC_VECTOR(65 downto 0 ) :=
            "ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ";
            R_TYPE : out STD_LOGIC_VECTOR(2 downto 0 );
            rx_data : out STD_LOGIC_VECTOR(63 downto 0 );
            rx_control : out STD_LOGIC_VECTOR(7 downto 0 )
            );
  end component;
  component RX_FSM
      generic (
            STATE_SIMPLIFIED : boolean := true
      );
      port (
            clk156 : in STD_LOGIC := 'Z';
            rstb156 : in STD_LOGIC := 'Z';
            errd_blks : out STD_LOGIC_VECTOR(7 downto 0 );
            lpbk : in STD_LOGIC := 'Z';
            clear_errblk : in STD_LOGIC := 'Z';
            hi_ber : in STD_LOGIC := 'Z';
            blk_lock : in STD_LOGIC := 'Z';
            bypass_66decoder : in STD_LOGIC := 'Z';
            rx_data : in STD_LOGIC_VECTOR(63 downto 0 ) :=
            "ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ";
            rx_control : in STD_LOGIC_VECTOR(7 downto 0 ) := "ZZZZZZZZ";
            rxcontrol : out STD_LOGIC_VECTOR(7 downto 0 );
            rxdata : out STD_LOGIC_VECTOR(63 downto 0 );
            R_TYPE : in STD_LOGIC_VECTOR(2 downto 0 ) := "ZZZ";
            DeScr_RXD : in STD_LOGIC_VECTOR(63 downto 0 ) :=
            "ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ";
            rxlf : out STD_LOGIC;
            STATE_PREV : in STD_LOGIC_VECTOR(2 downto 0 );
            STATE      : out STD_LOGIC_VECTOR(2 downto 0 );
            DEC_ERROR  : out STD_LOGIC; -- Block decode error
            SEQ_ERROR  : out STD_LOGIC; -- Block sequencing error
            STATE_O    : out std_logic_vector(2 downto 0)
      );
  end component;
  --   local signals
  signal R_TYPE : STD_LOGIC_VECTOR(2 downto 0 );
  signal rx_control : STD_LOGIC_VECTOR(7 downto 0 );
  signal rx_data : STD_LOGIC_VECTOR(63 downto 0 );
begin
 
 
  visual_0_R_TYPE_Decode: R_TYPE_Decode
    port map (
              rstb156    => rstb156,
              clk156     => clk156,
              DeScr_RXD  => DeScr_RXD(65 downto 0),
              R_TYPE     => R_TYPE(2 downto 0),
              rx_data    => rx_data(63 downto 0),
              rx_control => rx_control(7 downto 0)
              );
 
  --   input ports
  --   output ports
  visual_0_RX_FSM: RX_FSM
    generic map (
              STATE_SIMPLIFIED => STATE_SIMPLIFIED
    )
    port map (
              clk156 => clk156,
              rstb156 => rstb156,
              lpbk => lpbk,
              clear_errblk => clear_errblk,
              hi_ber => hi_ber,
              blk_lock => blk_lock,
              bypass_66decoder => bypass_66decoder,
              rx_data    => rx_data(63 downto 0),
              rx_control => rx_control(7 downto 0),
              R_TYPE     => R_TYPE(2 downto 0),
              DeScr_RXD  => DeScr_RXD(65 downto 2),
              errd_blks  => errd_blks(7 downto 0),
              rxcontrol  => rxcontrol(7 downto 0),
              rxdata     => rxdata(63 downto 0),
              rxlf       => rxlf,
              STATE_PREV => STATE_PREV,
              STATE      => STATE,
              DEC_ERROR  => DEC_ERROR,
              SEQ_ERROR  => SEQ_ERROR,
              STATE_O    => STATE_O
    );
  --   input ports
  --   output ports
  --  Decode
 
end ;

