library ieee;
use ieee.std_logic_1164.all;

entity crc32_fast128_tab is

	port (
		DI : in std_logic_vector(127 downto 0);
		DO : out std_logic_vector(31 downto 0)
	);

end entity;

architecture structural of crc32_fast128_tab is

	signal out1 : std_logic_vector(245 downto 0);

	signal out2 : std_logic_vector(264 downto 0);

	signal out3 : std_logic_vector(206 downto 0);

	signal out4 : std_logic_vector(131 downto 0);

	signal out5 : std_logic_vector(72 downto 0);

	signal out6 : std_logic_vector(40 downto 0);

	signal out7 : std_logic_vector(31 downto 0);

begin

	out1(0) <= DI(5) XOR DI(14);
	out1(1) <= DI(29) XOR DI(75);
	out1(2) <= DI(11) XOR DI(32);
	out1(3) <= DI(2) XOR DI(118);
	out1(4) <= DI(24) XOR DI(80);
	out1(5) <= DI(17) XOR DI(70);
	out1(6) <= DI(46) XOR DI(99);
	out1(7) <= DI(63) XOR DI(65);
	out1(8) <= DI(33) XOR DI(103);
	out1(9) <= DI(30) XOR DI(68);
	out1(10) <= DI(15) XOR DI(27);
	out1(11) <= DI(78) XOR DI(100);
	out1(12) <= DI(12) XOR DI(98);
	out1(13) <= DI(18) XOR DI(45);
	out1(14) <= DI(34) XOR DI(62);
	out1(15) <= DI(3) XOR DI(91);
	out1(16) <= DI(43) XOR DI(83);
	out1(17) <= DI(94) XOR DI(119);
	out1(18) <= DI(47) XOR DI(67);
	out1(19) <= DI(73) XOR DI(102);
	out1(20) <= DI(10) XOR DI(96);
	out1(21) <= DI(25) XOR DI(41);
	out1(22) <= DI(49) XOR DI(122);
	out1(23) <= DI(0) XOR DI(9);
	out1(24) <= DI(55) XOR DI(97);
	out1(25) <= DI(1) XOR DI(44);
	out1(26) <= DI(31) XOR DI(74);
	out1(27) <= DI(61) XOR DI(84);
	out1(28) <= DI(81) XOR DI(112);
	out1(29) <= DI(22) XOR DI(116);
	out1(30) <= DI(56) XOR DI(60);
	out1(31) <= DI(104);
	out1(32) <= DI(48) XOR DI(69);
	out1(33) <= DI(16) XOR DI(28);
	out1(34) <= DI(79) XOR DI(101);
	out1(35) <= DI(34) XOR DI(35);
	out1(36) <= DI(13) XOR DI(26);
	out1(37) <= DI(95) XOR DI(120);
	out1(38) <= DI(15) XOR DI(57);
	out1(39) <= DI(6) XOR DI(44);
	out1(40) <= DI(3) XOR DI(76);
	out1(41) <= DI(62) XOR DI(82);
	out1(42) <= DI(1) XOR DI(85);
	out1(43) <= DI(64) XOR DI(66);
	out1(44) <= DI(50) XOR DI(123);
	out1(45) <= DI(19) XOR DI(42);
	out1(46) <= DI(56) XOR DI(71);
	out1(47) <= DI(25) XOR DI(47);
	out1(48) <= DI(81) XOR DI(92);
	out1(49) <= DI(97) XOR DI(105);
	out1(50) <= DI(100) XOR DI(113);
	out1(51) <= DI(10) XOR DI(23);
	out1(52) <= DI(2) XOR DI(63);
	out1(53) <= DI(4) XOR DI(75);
	out1(54) <= DI(104) XOR DI(117);
	out1(55) <= DI(119);
	out1(56) <= DI(4) XOR DI(77);
	out1(57) <= DI(20) XOR DI(121);
	out1(58) <= DI(86) XOR DI(106);
	out1(59) <= DI(7) XOR DI(36);
	out1(60) <= DI(57) XOR DI(72);
	out1(61) <= DI(51) XOR DI(124);
	out1(62) <= DI(93) XOR DI(104);
	out1(63) <= DI(27) XOR DI(58);
	out1(64) <= DI(19) XOR DI(105);
	out1(65) <= DI(101) XOR DI(114);
	out1(66) <= DI(45) XOR DI(120);
	out1(67) <= DI(16) XOR DI(49);
	out1(68) <= DI(31) XOR DI(64);
	out1(69) <= DI(85) XOR DI(102);
	out1(70) <= DI(33) XOR DI(96);
	out1(71) <= DI(100);
	out1(72) <= DI(8) XOR DI(37);
	out1(73) <= DI(87) XOR DI(107);
	out1(74) <= DI(21) XOR DI(58);
	out1(75) <= DI(81) XOR DI(83);
	out1(76) <= DI(52) XOR DI(125);
	out1(77) <= DI(59) XOR DI(115);
	out1(78) <= DI(18) XOR DI(50);
	out1(79) <= DI(12) XOR DI(48);
	out1(80) <= DI(13) XOR DI(28);
	out1(81) <= DI(32) XOR DI(36);
	out1(82) <= DI(71) XOR DI(84);
	out1(83) <= DI(101);
	out1(84) <= DI(53) XOR DI(126);
	out1(85) <= DI(71) XOR DI(106);
	out1(86) <= DI(65) XOR DI(72);
	out1(87) <= DI(88) XOR DI(108);
	out1(88) <= DI(21) XOR DI(29);
	out1(89) <= DI(59) XOR DI(98);
	out1(90) <= DI(6) XOR DI(38);
	out1(91) <= DI(51) XOR DI(82);
	out1(92) <= DI(15) XOR DI(19);
	out1(93) <= DI(37) XOR DI(60);
	out1(94) <= DI(84) XOR DI(104);
	out1(95) <= DI(22) XOR DI(23);
	out1(96) <= DI(38) XOR DI(39);
	out1(97) <= DI(60) XOR DI(89);
	out1(98) <= DI(66) XOR DI(67);
	out1(99) <= DI(54) XOR DI(127);
	out1(100) <= DI(48) XOR DI(52);
	out1(101) <= DI(6) XOR DI(80);
	out1(102) <= DI(83) XOR DI(86);
	out1(103) <= DI(104) XOR DI(107);
	out1(104) <= DI(61) XOR DI(109);
	out1(105) <= DI(78) XOR DI(103);
	out1(106) <= DI(32) XOR DI(117);
	out1(107) <= DI(40) XOR DI(110);
	out1(108) <= DI(32) XOR DI(69);
	out1(109) <= DI(20) XOR DI(87);
	out1(110) <= DI(53) XOR DI(70);
	out1(111) <= DI(90) XOR DI(108);
	out1(112) <= DI(91) XOR DI(109);
	out1(113) <= DI(1) XOR DI(21);
	out1(114) <= DI(27) XOR DI(116);
	out1(115) <= DI(45) XOR DI(79);
	out1(116) <= DI(78) XOR DI(112);
	out1(117) <= DI(50) XOR DI(66);
	out1(118) <= DI(105);
	out1(119) <= DI(90) XOR DI(117);
	out1(120) <= DI(92) XOR DI(111);
	out1(121) <= DI(15) XOR DI(76);
	out1(122) <= DI(33) XOR DI(41);
	out1(123) <= DI(35) XOR DI(54);
	out1(124) <= DI(2) XOR DI(11);
	out1(125) <= DI(28) XOR DI(30);
	out1(126) <= DI(42) XOR DI(51);
	out1(127) <= DI(88) XOR DI(97);
	out1(128) <= DI(16) XOR DI(77);
	out1(129) <= DI(42) XOR DI(43);
	out1(130) <= DI(46) XOR DI(89);
	out1(131) <= DI(55) XOR DI(71);
	out1(132) <= DI(73) XOR DI(93);
	out1(133) <= DI(118) XOR DI(121);
	out1(134) <= DI(29) XOR DI(31);
	out1(135) <= DI(107);
	out1(136) <= DI(4) XOR DI(28);
	out1(137) <= DI(3) XOR DI(40);
	out1(138) <= DI(96) XOR DI(118);
	out1(139) <= DI(17) XOR DI(93);
	out1(140) <= DI(13) XOR DI(109);
	out1(141) <= DI(65) XOR DI(66);
	out1(142) <= DI(75) XOR DI(92);
	out1(143) <= DI(122);
	out1(144) <= DI(20) XOR DI(91);
	out1(145) <= DI(23) XOR DI(24);
	out1(146) <= DI(39) XOR DI(102);
	out1(147) <= DI(111) XOR DI(115);
	out1(148) <= DI(19) XOR DI(21);
	out1(149) <= DI(34) XOR DI(88);
	out1(150) <= DI(123);
	out1(151) <= DI(13) XOR DI(56);
	out1(152) <= DI(49) XOR DI(105);
	out1(153) <= DI(20) XOR DI(40);
	out1(154) <= DI(112) XOR DI(124);
	out1(155) <= DI(68) XOR DI(113);
	out1(156) <= DI(9) XOR DI(99);
	out1(157) <= DI(59) XOR DI(125);
	out1(158) <= DI(6) XOR DI(47);
	out1(159) <= DI(50) XOR DI(106);
	out1(160) <= DI(40) XOR DI(121);
	out1(161) <= DI(79) XOR DI(113);
	out1(162) <= DI(26) XOR DI(94);
	out1(163) <= DI(16) XOR DI(35);
	out1(164) <= DI(114) XOR DI(126);
	out1(165) <= DI(61) XOR DI(95);
	out1(166) <= DI(11) XOR DI(114);
	out1(167) <= DI(119) XOR DI(127);
	out1(168) <= DI(30) XOR DI(38);
	out1(169) <= DI(52);
	out1(170) <= DI(7) XOR DI(74);
	out1(171) <= DI(3) XOR DI(112);
	out1(172) <= DI(72) XOR DI(75);
	out1(173) <= DI(82) XOR DI(106);
	out1(174) <= DI(107) XOR DI(120);
	out1(175) <= DI(8) XOR DI(73);
	out1(176) <= DI(17) XOR DI(116);
	out1(177) <= DI(84) XOR DI(108);
	out1(178) <= DI(4) XOR DI(9);
	out1(179) <= DI(33) XOR DI(54);
	out1(180) <= DI(30) XOR DI(111);
	out1(181) <= DI(5) XOR DI(55);
	out1(182) <= DI(39) XOR DI(67);
	out1(183) <= DI(85) XOR DI(105);
	out1(184) <= DI(114) XOR DI(117);
	out1(185) <= DI(0) XOR DI(35);
	out1(186) <= DI(46) XOR DI(76);
	out1(187) <= DI(22) XOR DI(26);
	out1(188) <= DI(58) XOR DI(85);
	out1(189) <= DI(97) XOR DI(109);
	out1(190) <= DI(63) XOR DI(110);
	out1(191) <= DI(70) XOR DI(77);
	out1(192) <= DI(25) XOR DI(29);
	out1(193) <= DI(45) XOR DI(49);
	out1(194) <= DI(68) XOR DI(69);
	out1(195) <= DI(99) XOR DI(111);
	out1(196) <= DI(112) XOR DI(123);
	out1(197) <= DI(0) XOR DI(7);
	out1(198) <= DI(17) XOR DI(38);
	out1(199) <= DI(65) XOR DI(91);
	out1(200) <= DI(99) XOR DI(124);
	out1(201) <= DI(8) XOR DI(88);
	out1(202) <= DI(51) XOR DI(80);
	out1(203) <= DI(86) XOR DI(125);
	out1(204) <= DI(14) XOR DI(63);
	out1(205) <= DI(66) XOR DI(94);
	out1(206) <= DI(95) XOR DI(103);
	out1(207) <= DI(114) XOR DI(118);
	out1(208) <= DI(14) XOR DI(64);
	out1(209) <= DI(96) XOR DI(126);
	out1(210) <= DI(7) XOR DI(24);
	out1(211) <= DI(39) XOR DI(44);
	out1(212) <= DI(57) XOR DI(58);
	out1(213) <= DI(75) XOR DI(95);
	out1(214) <= DI(5) XOR DI(34);
	out1(215) <= DI(40) XOR DI(53);
	out1(216) <= DI(82) XOR DI(84);
	out1(217) <= DI(99) XOR DI(103);
	out1(218) <= DI(43) XOR DI(54);
	out1(219) <= DI(0) XOR DI(48);
	out1(220) <= DI(113) XOR DI(116);
	out1(221) <= DI(119) XOR DI(122);
	out1(222) <= DI(24) XOR DI(47);
	out1(223) <= DI(62) XOR DI(73);
	out1(224) <= DI(74) XOR DI(78);
	out1(225) <= DI(123) XOR DI(124);
	out1(226) <= DI(18) XOR DI(41);
	out1(227) <= DI(57) XOR DI(79);
	out1(228) <= DI(97) XOR DI(98);
	out1(229) <= DI(102) XOR DI(116);
	out1(230) <= DI(121) XOR DI(124);
	out1(231) <= DI(5) XOR DI(24);
	out1(232) <= DI(38) XOR DI(87);
	out1(233) <= DI(110);
	out1(234) <= DI(59) XOR DI(90);
	out1(235) <= DI(113) XOR DI(118);
	out1(236) <= DI(12) XOR DI(39);
	out1(237) <= DI(62) XOR DI(68);
	out1(238) <= DI(89) XOR DI(90);
	out1(239) <= DI(115) XOR DI(120);
	out1(240) <= DI(127);
	out1(241) <= DI(8) XOR DI(14);
	out1(242) <= DI(23) XOR DI(42);
	out1(243) <= DI(45) XOR DI(60);
	out1(244) <= DI(67) XOR DI(72);
	out1(245) <= DI(98);

	out2(0) <= out1(0) XOR out1(1);
	out2(1) <= out1(2) XOR out1(3);
	out2(2) <= out1(4) XOR out1(5);
	out2(3) <= out1(6) XOR out1(7);
	out2(4) <= out1(8) XOR out1(9);
	out2(5) <= out1(10) XOR out1(11);
	out2(6) <= out1(12) XOR out1(13);
	out2(7) <= out1(14) XOR out1(15);
	out2(8) <= out1(16) XOR out1(17);
	out2(9) <= out1(18) XOR out1(19);
	out2(10) <= out1(20) XOR out1(21);
	out2(11) <= out1(22) XOR out1(23);
	out2(12) <= out1(24) XOR out1(25);
	out2(13) <= out1(26) XOR out1(27);
	out2(14) <= out1(28) XOR out1(29);
	out2(15) <= out1(30) XOR out1(31);
	out2(16) <= out1(32) XOR out1(26);
	out2(17) <= out1(33) XOR out1(34);
	out2(18) <= out1(35) XOR out1(36);
	out2(19) <= out1(37) XOR out1(38);
	out2(20) <= out1(39) XOR out1(40);
	out2(21) <= out1(41) XOR out1(27);
	out2(22) <= out1(2) XOR out1(42);
	out2(23) <= out1(6) XOR out1(43);
	out2(24) <= out1(44) XOR out1(45);
	out2(25) <= out1(46) XOR out1(47);
	out2(26) <= out1(48) XOR out1(49);
	out2(27) <= out1(50) XOR out1(51);
	out2(28) <= out1(52) XOR out1(53);
	out2(29) <= out1(54) XOR out1(55);
	out2(30) <= out1(18) XOR out1(56);
	out2(31) <= out1(40) XOR out1(32);
	out2(32) <= out1(57) XOR out1(58);
	out2(33) <= out1(59) XOR out1(60);
	out2(34) <= out1(12) XOR out1(16);
	out2(35) <= out1(61) XOR out1(62);
	out2(36) <= out1(41) XOR out1(63);
	out2(37) <= out1(64) XOR out1(65);
	out2(38) <= out1(66) XOR out1(67);
	out2(39) <= out1(68) XOR out1(69);
	out2(40) <= out1(70) XOR out1(71);
	out2(41) <= out1(72) XOR out1(17);
	out2(42) <= out1(0) XOR out1(73);
	out2(43) <= out1(35) XOR out1(19);
	out2(44) <= out1(22) XOR out1(74);
	out2(45) <= out1(56) XOR out1(75);
	out2(46) <= out1(5) XOR out1(43);
	out2(47) <= out1(76) XOR out1(77);
	out2(48) <= out1(47) XOR out1(49);
	out2(49) <= out1(78) XOR out1(79);
	out2(50) <= out1(80) XOR out1(81);
	out2(51) <= out1(82) XOR out1(83);
	out2(52) <= out1(84) XOR out1(73);
	out2(53) <= out1(37) XOR out1(23);
	out2(54) <= out1(59) XOR out1(85);
	out2(55) <= out1(8) XOR out1(86);
	out2(56) <= out1(0) XOR out1(87);
	out2(57) <= out1(13) XOR out1(11);
	out2(58) <= out1(44) XOR out1(29);
	out2(59) <= out1(22) XOR out1(43);
	out2(60) <= out1(88) XOR out1(89);
	out2(61) <= out1(69) XOR out1(90);
	out2(62) <= out1(91) XOR out1(92);
	out2(63) <= out1(93) XOR out1(94);
	out2(64) <= out1(72) XOR out1(95);
	out2(65) <= out1(96) XOR out1(97);
	out2(66) <= out1(34) XOR out1(98);
	out2(67) <= out1(59) XOR out1(20);
	out2(68) <= out1(10) XOR out1(44);
	out2(69) <= out1(99) XOR out1(42);
	out2(70) <= out1(9) XOR out1(100);
	out2(71) <= out1(5) XOR out1(57);
	out2(72) <= out1(101) XOR out1(102);
	out2(73) <= out1(6) XOR out1(61);
	out2(74) <= out1(87) XOR out1(64);
	out2(75) <= out1(86) XOR out1(103);
	out2(76) <= out1(67) XOR out1(104);
	out2(77) <= out1(105) XOR out1(106);
	out2(78) <= out1(46) XOR out1(61);
	out2(79) <= out1(21) XOR out1(107);
	out2(80) <= out1(33) XOR out1(108);
	out2(81) <= out1(76) XOR out1(58);
	out2(82) <= out1(12) XOR out1(109);
	out2(83) <= out1(110) XOR out1(111);
	out2(84) <= out1(35) XOR out1(112);
	out2(85) <= out1(113) XOR out1(114);
	out2(86) <= out1(115) XOR out1(116);
	out2(87) <= out1(117) XOR out1(118);
	out2(88) <= out1(60) XOR out1(76);
	out2(89) <= out1(96) XOR out1(107);
	out2(90) <= out1(36) XOR out1(119);
	out2(91) <= out1(39) XOR out1(112);
	out2(92) <= out1(120) XOR out1(50);
	out2(93) <= out1(27) XOR out1(121);
	out2(94) <= out1(88) XOR out1(122);
	out2(95) <= out1(115) XOR out1(123);
	out2(96) <= out1(124) XOR out1(125);
	out2(97) <= out1(126) XOR out1(127);
	out2(98) <= out1(28) XOR out1(128);
	out2(99) <= out1(4) XOR out1(23);
	out2(100) <= out1(96) XOR out1(129);
	out2(101) <= out1(120) XOR out1(65);
	out2(102) <= out1(18) XOR out1(84);
	out2(103) <= out1(11) XOR out1(86);
	out2(104) <= out1(130) XOR out1(63);
	out2(105) <= out1(131) XOR out1(132);
	out2(106) <= out1(133) XOR out1(134);
	out2(107) <= out1(135);
	out2(108) <= out1(99) XOR out1(77);
	out2(109) <= out1(45) XOR out1(112);
	out2(110) <= out1(32) XOR out1(62);
	out2(111) <= out1(136) XOR out1(114);
	out2(112) <= out1(137) XOR out1(138);
	out2(113) <= out1(8) XOR out1(139);
	out2(114) <= out1(95) XOR out1(119);
	out2(115) <= out1(26) XOR out1(11);
	out2(116) <= out1(42) XOR out1(109);
	out2(117) <= out1(136) XOR out1(140);
	out2(118) <= out1(123) XOR out1(141);
	out2(119) <= out1(142) XOR out1(143);
	out2(120) <= out1(56) XOR out1(13);
	out2(121) <= out1(36) XOR out1(24);
	out2(122) <= out1(40) XOR out1(6);
	out2(123) <= out1(107) XOR out1(58);
	out2(124) <= out1(62) XOR out1(122);
	out2(125) <= out1(79) XOR out1(144);
	out2(126) <= out1(145) XOR out1(146);
	out2(127) <= out1(147) XOR out1(148);
	out2(128) <= out1(149) XOR out1(150);
	out2(129) <= out1(4) XOR out1(74);
	out2(130) <= out1(120) XOR out1(29);
	out2(131) <= out1(21) XOR out1(151);
	out2(132) <= out1(40) XOR out1(12);
	out2(133) <= out1(45) XOR out1(130);
	out2(134) <= out1(90) XOR out1(152);
	out2(135) <= out1(153) XOR out1(154);
	out2(136) <= out1(57) XOR out1(155);
	out2(137) <= out1(56) XOR out1(21);
	out2(138) <= out1(62) XOR out1(28);
	out2(139) <= out1(156) XOR out1(105);
	out2(140) <= out1(113) XOR out1(157);
	out2(141) <= out1(158) XOR out1(159);
	out2(142) <= out1(32) XOR out1(97);
	out2(143) <= out1(160) XOR out1(161);
	out2(144) <= out1(49) XOR out1(129);
	out2(145) <= out1(162) XOR out1(103);
	out2(146) <= out1(91) XOR out1(146);
	out2(147) <= out1(163) XOR out1(164);
	out2(148) <= out1(16) XOR out1(165);
	out2(149) <= out1(8) XOR out1(77);
	out2(150) <= out1(166) XOR out1(111);
	out2(151) <= out1(167) XOR out1(168);
	out2(152) <= out1(169);
	out2(153) <= out1(7) XOR out1(170);
	out2(154) <= out1(0) XOR out1(33);
	out2(155) <= out1(96) XOR out1(22);
	out2(156) <= out1(110) XOR out1(104);
	out2(157) <= out1(132) XOR out1(147);
	out2(158) <= out1(171) XOR out1(172);
	out2(159) <= out1(173) XOR out1(174);
	out2(160) <= out1(12) XOR out1(37);
	out2(161) <= out1(43) XOR out1(14);
	out2(162) <= out1(103) XOR out1(175);
	out2(163) <= out1(116) XOR out1(145);
	out2(164) <= out1(176) XOR out1(177);
	out2(165) <= out1(178) XOR out1(179);
	out2(166) <= out1(1) XOR out1(37);
	out2(167) <= out1(121) XOR out1(156);
	out2(168) <= out1(39) XOR out1(61);
	out2(169) <= out1(84) XOR out1(140);
	out2(170) <= out1(180) XOR out1(177);
	out2(171) <= out1(181) XOR out1(182);
	out2(172) <= out1(183) XOR out1(184);
	out2(173) <= out1(84) XOR out1(166);
	out2(174) <= out1(46) XOR out1(26);
	out2(175) <= out1(101) XOR out1(175);
	out2(176) <= out1(133) XOR out1(185);
	out2(177) <= out1(186) XOR out1(187);
	out2(178) <= out1(188) XOR out1(189);
	out2(179) <= out1(143);
	out2(180) <= out1(3) XOR out1(162);
	out2(181) <= out1(0) XOR out1(8);
	out2(182) <= out1(4) XOR out1(60);
	out2(183) <= out1(19) XOR out1(34);
	out2(184) <= out1(45) XOR out1(50);
	out2(185) <= out1(102) XOR out1(144);
	out2(186) <= out1(190) XOR out1(191);
	out2(187) <= out1(192) XOR out1(193);
	out2(188) <= out1(194) XOR out1(195);
	out2(189) <= out1(196);
	out2(190) <= out1(39) XOR out1(87);
	out2(191) <= out1(20) XOR out1(46);
	out2(192) <= out1(108) XOR out1(78);
	out2(193) <= out1(122) XOR out1(155);
	out2(194) <= out1(165) XOR out1(68);
	out2(195) <= out1(197) XOR out1(198);
	out2(196) <= out1(199) XOR out1(200);
	out2(197) <= out1(1) XOR out1(201);
	out2(198) <= out1(51) XOR out1(202);
	out2(199) <= out1(60) XOR out1(77);
	out2(200) <= out1(27) XOR out1(62);
	out2(201) <= out1(48) XOR out1(176);
	out2(202) <= out1(186) XOR out1(197);
	out2(203) <= out1(203) XOR out1(204);
	out2(204) <= out1(205) XOR out1(206);
	out2(205) <= out1(207);
	out2(206) <= out1(18) XOR out1(13);
	out2(207) <= out1(17) XOR out1(107);
	out2(208) <= out1(97) XOR out1(48);
	out2(209) <= out1(109) XOR out1(129);
	out2(210) <= out1(175) XOR out1(208);
	out2(211) <= out1(209) XOR out1(152);
	out2(212) <= out1(191) XOR out1(210);
	out2(213) <= out1(211) XOR out1(212);
	out2(214) <= out1(213);
	out2(215) <= out1(64) XOR out1(89);
	out2(216) <= out1(74) XOR out1(62);
	out2(217) <= out1(78) XOR out1(167);
	out2(218) <= out1(180) XOR out1(201);
	out2(219) <= out1(214) XOR out1(215);
	out2(220) <= out1(216) XOR out1(217);
	out2(221) <= out1(130) XOR out1(218);
	out2(222) <= out1(10) XOR out1(46);
	out2(223) <= out1(7) XOR out1(24);
	out2(224) <= out1(66) XOR out1(219);
	out2(225) <= out1(220) XOR out1(221);
	out2(226) <= out1(150);
	out2(227) <= out1(12) XOR out1(33);
	out2(228) <= out1(119) XOR out1(100);
	out2(229) <= out1(121) XOR out1(166);
	out2(230) <= out1(66) XOR out1(30);
	out2(231) <= out1(52) XOR out1(181);
	out2(232) <= out1(185) XOR out1(222);
	out2(233) <= out1(223) XOR out1(224);
	out2(234) <= out1(225);
	out2(235) <= out1(72) XOR out1(2);
	out2(236) <= out1(74) XOR out1(41);
	out2(237) <= out1(73) XOR out1(110);
	out2(238) <= out1(140) XOR out1(208);
	out2(239) <= out1(203) XOR out1(226);
	out2(240) <= out1(227) XOR out1(228);
	out2(241) <= out1(229) XOR out1(230);
	out2(242) <= out1(9) XOR out1(3);
	out2(243) <= out1(87) XOR out1(119);
	out2(244) <= out1(50) XOR out1(170);
	out2(245) <= out1(209) XOR out1(157);
	out2(246) <= out1(171) XOR out1(226);
	out2(247) <= out1(231) XOR out1(232);
	out2(248) <= out1(233);
	out2(249) <= out1(16) XOR out1(24);
	out2(250) <= out1(47) XOR out1(136);
	out2(251) <= out1(167) XOR out1(209);
	out2(252) <= out1(190) XOR out1(234);
	out2(253) <= out1(235);
	out2(254) <= out1(57) XOR out1(170);
	out2(255) <= out1(75) XOR out1(208);
	out2(256) <= out1(131) XOR out1(236);
	out2(257) <= out1(237) XOR out1(238);
	out2(258) <= out1(239) XOR out1(240);
	out2(259) <= out1(56) XOR out1(20);
	out2(260) <= out1(19) XOR out1(41);
	out2(261) <= out1(88) XOR out1(160);
	out2(262) <= out1(180) XOR out1(241);
	out2(263) <= out1(242) XOR out1(243);
	out2(264) <= out1(244) XOR out1(245);

	out3(0) <= out2(0) XOR out2(1);
	out3(1) <= out2(2) XOR out2(3);
	out3(2) <= out2(4) XOR out2(5);
	out3(3) <= out2(6) XOR out2(7);
	out3(4) <= out2(8) XOR out2(9);
	out3(5) <= out2(10) XOR out2(11);
	out3(6) <= out2(12) XOR out2(13);
	out3(7) <= out2(14) XOR out2(15);
	out3(8) <= out2(16) XOR out2(17);
	out3(9) <= out2(18) XOR out2(19);
	out3(10) <= out2(20) XOR out2(6);
	out3(11) <= out2(21) XOR out2(22);
	out3(12) <= out2(4) XOR out2(23);
	out3(13) <= out2(24) XOR out2(25);
	out3(14) <= out2(26) XOR out2(27);
	out3(15) <= out2(28) XOR out2(29);
	out3(16) <= out2(30) XOR out2(31);
	out3(17) <= out2(32) XOR out2(33);
	out3(18) <= out2(18) XOR out2(34);
	out3(19) <= out2(35) XOR out2(36);
	out3(20) <= out2(37) XOR out2(38);
	out3(21) <= out2(39) XOR out2(40);
	out3(22) <= out2(41) XOR out2(42);
	out3(23) <= out2(20) XOR out2(43);
	out3(24) <= out2(44) XOR out2(45);
	out3(25) <= out2(3) XOR out2(32);
	out3(26) <= out2(46) XOR out2(47);
	out3(27) <= out2(48) XOR out2(49);
	out3(28) <= out2(50) XOR out2(51);
	out3(29) <= out2(30) XOR out2(52);
	out3(30) <= out2(53) XOR out2(54);
	out3(31) <= out2(18) XOR out2(55);
	out3(32) <= out2(56) XOR out2(57);
	out3(33) <= out2(58) XOR out2(59);
	out3(34) <= out2(60) XOR out2(61);
	out3(35) <= out2(62) XOR out2(63);
	out3(36) <= out2(0) XOR out2(64);
	out3(37) <= out2(65) XOR out2(66);
	out3(38) <= out2(67) XOR out2(68);
	out3(39) <= out2(69) XOR out2(70);
	out3(40) <= out2(43) XOR out2(71);
	out3(41) <= out2(72) XOR out2(73);
	out3(42) <= out2(74) XOR out2(75);
	out3(43) <= out2(76) XOR out2(77);
	out3(44) <= out2(20) XOR out2(78);
	out3(45) <= out2(67) XOR out2(79);
	out3(46) <= out2(3) XOR out2(8);
	out3(47) <= out2(65) XOR out2(80);
	out3(48) <= out2(81) XOR out2(82);
	out3(49) <= out2(83) XOR out2(84);
	out3(50) <= out2(85) XOR out2(86);
	out3(51) <= out2(87);
	out3(52) <= out2(64) XOR out2(2);
	out3(53) <= out2(88) XOR out2(89);
	out3(54) <= out2(23) XOR out2(90);
	out3(55) <= out2(91) XOR out2(92);
	out3(56) <= out2(93) XOR out2(94);
	out3(57) <= out2(95) XOR out2(96);
	out3(58) <= out2(97);
	out3(59) <= out2(98) XOR out2(99);
	out3(60) <= out2(56) XOR out2(100);
	out3(61) <= out2(64) XOR out2(101);
	out3(62) <= out2(102) XOR out2(103);
	out3(63) <= out2(104) XOR out2(105);
	out3(64) <= out2(106) XOR out2(107);
	out3(65) <= out2(108) XOR out2(21);
	out3(66) <= out2(6) XOR out2(109);
	out3(67) <= out2(72) XOR out2(83);
	out3(68) <= out2(92) XOR out2(110);
	out3(69) <= out2(111) XOR out2(112);
	out3(70) <= out2(67) XOR out2(1);
	out3(71) <= out2(89) XOR out2(113);
	out3(72) <= out2(114) XOR out2(25);
	out3(73) <= out2(37) XOR out2(115);
	out3(74) <= out2(116) XOR out2(117);
	out3(75) <= out2(118) XOR out2(119);
	out3(76) <= out2(41) XOR out2(33);
	out3(77) <= out2(66) XOR out2(120);
	out3(78) <= out2(121) XOR out2(122);
	out3(79) <= out2(123) XOR out2(124);
	out3(80) <= out2(125) XOR out2(126);
	out3(81) <= out2(127) XOR out2(128);
	out3(82) <= out2(129) XOR out2(130);
	out3(83) <= out2(30) XOR out2(43);
	out3(84) <= out2(53) XOR out2(131);
	out3(85) <= out2(132) XOR out2(133);
	out3(86) <= out2(134) XOR out2(135);
	out3(87) <= out2(67) XOR out2(114);
	out3(88) <= out2(136) XOR out2(137);
	out3(89) <= out2(138) XOR out2(139);
	out3(90) <= out2(140) XOR out2(141);
	out3(91) <= out2(2) XOR out2(44);
	out3(92) <= out2(5) XOR out2(91);
	out3(93) <= out2(142) XOR out2(143);
	out3(94) <= out2(144) XOR out2(145);
	out3(95) <= out2(146) XOR out2(147);
	out3(96) <= out2(17) XOR out2(79);
	out3(97) <= out2(68) XOR out2(54);
	out3(98) <= out2(11) XOR out2(26);
	out3(99) <= out2(148) XOR out2(149);
	out3(100) <= out2(150) XOR out2(151);
	out3(101) <= out2(152);
	out3(102) <= out2(64) XOR out2(30);
	out3(103) <= out2(1) XOR out2(78);
	out3(104) <= out2(8) XOR out2(24);
	out3(105) <= out2(121) XOR out2(153);
	out3(106) <= out2(154) XOR out2(155);
	out3(107) <= out2(156) XOR out2(157);
	out3(108) <= out2(158) XOR out2(159);
	out3(109) <= out2(0) XOR out2(8);
	out3(110) <= out2(68) XOR out2(136);
	out3(111) <= out2(160) XOR out2(161);
	out3(112) <= out2(162) XOR out2(163);
	out3(113) <= out2(164) XOR out2(165);
	out3(114) <= out2(80) XOR out2(166);
	out3(115) <= out2(88) XOR out2(43);
	out3(116) <= out2(10) XOR out2(120);
	out3(117) <= out2(143) XOR out2(153);
	out3(118) <= out2(167) XOR out2(168);
	out3(119) <= out2(169) XOR out2(170);
	out3(120) <= out2(171) XOR out2(172);
	out3(121) <= out2(4) XOR out2(108);
	out3(122) <= out2(98) XOR out2(81);
	out3(123) <= out2(0) XOR out2(24);
	out3(124) <= out2(46) XOR out2(57);
	out3(125) <= out2(173) XOR out2(174);
	out3(126) <= out2(175) XOR out2(176);
	out3(127) <= out2(177) XOR out2(178);
	out3(128) <= out2(179);
	out3(129) <= out2(64) XOR out2(67);
	out3(130) <= out2(52) XOR out2(180);
	out3(131) <= out2(181) XOR out2(182);
	out3(132) <= out2(183) XOR out2(184);
	out3(133) <= out2(185) XOR out2(186);
	out3(134) <= out2(187) XOR out2(188);
	out3(135) <= out2(189);
	out3(136) <= out2(88) XOR out2(101);
	out3(137) <= out2(69) XOR out2(190);
	out3(138) <= out2(30) XOR out2(44);
	out3(139) <= out2(180) XOR out2(82);
	out3(140) <= out2(191) XOR out2(192);
	out3(141) <= out2(193) XOR out2(194);
	out3(142) <= out2(195) XOR out2(196);
	out3(143) <= out2(16) XOR out2(65);
	out3(144) <= out2(44) XOR out2(24);
	out3(145) <= out2(91) XOR out2(34);
	out3(146) <= out2(102) XOR out2(131);
	out3(147) <= out2(197) XOR out2(198);
	out3(148) <= out2(199) XOR out2(200);
	out3(149) <= out2(201) XOR out2(202);
	out3(150) <= out2(203) XOR out2(204);
	out3(151) <= out2(205);
	out3(152) <= out2(108) XOR out2(70);
	out3(153) <= out2(90) XOR out2(35);
	out3(154) <= out2(58) XOR out2(167);
	out3(155) <= out2(206) XOR out2(207);
	out3(156) <= out2(208) XOR out2(209);
	out3(157) <= out2(210) XOR out2(211);
	out3(158) <= out2(212) XOR out2(213);
	out3(159) <= out2(214);
	out3(160) <= out2(78) XOR out2(9);
	out3(161) <= out2(2) XOR out2(22);
	out3(162) <= out2(31) XOR out2(114);
	out3(163) <= out2(166) XOR out2(215);
	out3(164) <= out2(216) XOR out2(217);
	out3(165) <= out2(218) XOR out2(219);
	out3(166) <= out2(220) XOR out2(179);
	out3(167) <= out2(0) XOR out2(88);
	out3(168) <= out2(32) XOR out2(198);
	out3(169) <= out2(215) XOR out2(221);
	out3(170) <= out2(222) XOR out2(223);
	out3(171) <= out2(224) XOR out2(225);
	out3(172) <= out2(226);
	out3(173) <= out2(52) XOR out2(227);
	out3(174) <= out2(228) XOR out2(229);
	out3(175) <= out2(230) XOR out2(231);
	out3(176) <= out2(232) XOR out2(233);
	out3(177) <= out2(234);
	out3(178) <= out2(8) XOR out2(190);
	out3(179) <= out2(142) XOR out2(235);
	out3(180) <= out2(236) XOR out2(237);
	out3(181) <= out2(238) XOR out2(239);
	out3(182) <= out2(240) XOR out2(241);
	out3(183) <= out2(41) XOR out2(109);
	out3(184) <= out2(36) XOR out2(221);
	out3(185) <= out2(242) XOR out2(243);
	out3(186) <= out2(244) XOR out2(245);
	out3(187) <= out2(246) XOR out2(247);
	out3(188) <= out2(248);
	out3(189) <= out2(4) XOR out2(20);
	out3(190) <= out2(53) XOR out2(109);
	out3(191) <= out2(71) XOR out2(197);
	out3(192) <= out2(249) XOR out2(250);
	out3(193) <= out2(251) XOR out2(252);
	out3(194) <= out2(253);
	out3(195) <= out2(5) XOR out2(3);
	out3(196) <= out2(79) XOR out2(113);
	out3(197) <= out2(180) XOR out2(173);
	out3(198) <= out2(254) XOR out2(255);
	out3(199) <= out2(256) XOR out2(257);
	out3(200) <= out2(258);
	out3(201) <= out2(1) XOR out2(108);
	out3(202) <= out2(99) XOR out2(113);
	out3(203) <= out2(12) XOR out2(148);
	out3(204) <= out2(259) XOR out2(260);
	out3(205) <= out2(261) XOR out2(262);
	out3(206) <= out2(263) XOR out2(264);

	out4(0) <= out3(0) XOR out3(1);
	out4(1) <= out3(2) XOR out3(3);
	out4(2) <= out3(4) XOR out3(5);
	out4(3) <= out3(6) XOR out3(7);
	out4(4) <= out3(8) XOR out3(9);
	out4(5) <= out3(10) XOR out3(11);
	out4(6) <= out3(12) XOR out3(13);
	out4(7) <= out3(14) XOR out3(15);
	out4(8) <= out3(16) XOR out3(17);
	out4(9) <= out3(18) XOR out3(19);
	out4(10) <= out3(20) XOR out3(21);
	out4(11) <= out3(2) XOR out3(22);
	out4(12) <= out3(23) XOR out3(24);
	out4(13) <= out3(25) XOR out3(26);
	out4(14) <= out3(27) XOR out3(28);
	out4(15) <= out3(29) XOR out3(30);
	out4(16) <= out3(8) XOR out3(31);
	out4(17) <= out3(32) XOR out3(33);
	out4(18) <= out3(34) XOR out3(35);
	out4(19) <= out3(36) XOR out3(37);
	out4(20) <= out3(38) XOR out3(39);
	out4(21) <= out3(40) XOR out3(41);
	out4(22) <= out3(42) XOR out3(43);
	out4(23) <= out3(36) XOR out3(44);
	out4(24) <= out3(45) XOR out3(46);
	out4(25) <= out3(47) XOR out3(48);
	out4(26) <= out3(49) XOR out3(50);
	out4(27) <= out3(51);
	out4(28) <= out3(52) XOR out3(53);
	out4(29) <= out3(54) XOR out3(55);
	out4(30) <= out3(56) XOR out3(57);
	out4(31) <= out3(58);
	out4(32) <= out3(45) XOR out3(3);
	out4(33) <= out3(39) XOR out3(59);
	out4(34) <= out3(60) XOR out3(61);
	out4(35) <= out3(62) XOR out3(63);
	out4(36) <= out3(64);
	out4(37) <= out3(31) XOR out3(65);
	out4(38) <= out3(66) XOR out3(67);
	out4(39) <= out3(68) XOR out3(69);
	out4(40) <= out3(10) XOR out3(70);
	out4(41) <= out3(71) XOR out3(72);
	out4(42) <= out3(73) XOR out3(74);
	out4(43) <= out3(75);
	out4(44) <= out3(0) XOR out3(76);
	out4(45) <= out3(77) XOR out3(78);
	out4(46) <= out3(79) XOR out3(80);
	out4(47) <= out3(81);
	out4(48) <= out3(82) XOR out3(83);
	out4(49) <= out3(84) XOR out3(85);
	out4(50) <= out3(86);
	out4(51) <= out3(60) XOR out3(87);
	out4(52) <= out3(88) XOR out3(89);
	out4(53) <= out3(90);
	out4(54) <= out3(36) XOR out3(70);
	out4(55) <= out3(91) XOR out3(92);
	out4(56) <= out3(93) XOR out3(94);
	out4(57) <= out3(95);
	out4(58) <= out3(10) XOR out3(52);
	out4(59) <= out3(96) XOR out3(97);
	out4(60) <= out3(98) XOR out3(99);
	out4(61) <= out3(100) XOR out3(101);
	out4(62) <= out3(2) XOR out3(102);
	out4(63) <= out3(103) XOR out3(104);
	out4(64) <= out3(105) XOR out3(106);
	out4(65) <= out3(107) XOR out3(108);
	out4(66) <= out3(8) XOR out3(44);
	out4(67) <= out3(53) XOR out3(109);
	out4(68) <= out3(110) XOR out3(111);
	out4(69) <= out3(112) XOR out3(113);
	out4(70) <= out3(91) XOR out3(114);
	out4(71) <= out3(115) XOR out3(116);
	out4(72) <= out3(117) XOR out3(118);
	out4(73) <= out3(119) XOR out3(120);
	out4(74) <= out3(45) XOR out3(121);
	out4(75) <= out3(122) XOR out3(123);
	out4(76) <= out3(124) XOR out3(125);
	out4(77) <= out3(126) XOR out3(127);
	out4(78) <= out3(128);
	out4(79) <= out3(44) XOR out3(65);
	out4(80) <= out3(129) XOR out3(130);
	out4(81) <= out3(131) XOR out3(132);
	out4(82) <= out3(133) XOR out3(134);
	out4(83) <= out3(135);
	out4(84) <= out3(36) XOR out3(136);
	out4(85) <= out3(137) XOR out3(138);
	out4(86) <= out3(139) XOR out3(140);
	out4(87) <= out3(141) XOR out3(142);
	out4(88) <= out3(143) XOR out3(144);
	out4(89) <= out3(145) XOR out3(146);
	out4(90) <= out3(147) XOR out3(148);
	out4(91) <= out3(149) XOR out3(150);
	out4(92) <= out3(151);
	out4(93) <= out3(11) XOR out3(152);
	out4(94) <= out3(153) XOR out3(154);
	out4(95) <= out3(155) XOR out3(156);
	out4(96) <= out3(157) XOR out3(158);
	out4(97) <= out3(159);
	out4(98) <= out3(122) XOR out3(160);
	out4(99) <= out3(161) XOR out3(162);
	out4(100) <= out3(163) XOR out3(164);
	out4(101) <= out3(165) XOR out3(166);
	out4(102) <= out3(11) XOR out3(29);
	out4(103) <= out3(23) XOR out3(167);
	out4(104) <= out3(168) XOR out3(169);
	out4(105) <= out3(170) XOR out3(171);
	out4(106) <= out3(172);
	out4(107) <= out3(12) XOR out3(17);
	out4(108) <= out3(24) XOR out3(137);
	out4(109) <= out3(173) XOR out3(174);
	out4(110) <= out3(175) XOR out3(176);
	out4(111) <= out3(177);
	out4(112) <= out3(38) XOR out3(59);
	out4(113) <= out3(121) XOR out3(178);
	out4(114) <= out3(179) XOR out3(180);
	out4(115) <= out3(181) XOR out3(182);
	out4(116) <= out3(114) XOR out3(160);
	out4(117) <= out3(183) XOR out3(184);
	out4(118) <= out3(185) XOR out3(186);
	out4(119) <= out3(187) XOR out3(188);
	out4(120) <= out3(136) XOR out3(143);
	out4(121) <= out3(189) XOR out3(190);
	out4(122) <= out3(191) XOR out3(192);
	out4(123) <= out3(193) XOR out3(194);
	out4(124) <= out3(16) XOR out3(82);
	out4(125) <= out3(195) XOR out3(196);
	out4(126) <= out3(197) XOR out3(198);
	out4(127) <= out3(199) XOR out3(200);
	out4(128) <= out3(8) XOR out3(54);
	out4(129) <= out3(201) XOR out3(202);
	out4(130) <= out3(203) XOR out3(204);
	out4(131) <= out3(205) XOR out3(206);

	out5(0) <= out4(0) XOR out4(1);
	out5(1) <= out4(2) XOR out4(3);
	out5(2) <= out4(4) XOR out4(5);
	out5(3) <= out4(6) XOR out4(7);
	out5(4) <= out4(0) XOR out4(8);
	out5(5) <= out4(9) XOR out4(10);
	out5(6) <= out4(11) XOR out4(12);
	out5(7) <= out4(13) XOR out4(14);
	out5(8) <= out4(15) XOR out4(16);
	out5(9) <= out4(17) XOR out4(18);
	out5(10) <= out4(19) XOR out4(20);
	out5(11) <= out4(21) XOR out4(22);
	out5(12) <= out4(23) XOR out4(24);
	out5(13) <= out4(25) XOR out4(26);
	out5(14) <= out4(27);
	out5(15) <= out4(15) XOR out4(28);
	out5(16) <= out4(29) XOR out4(30);
	out5(17) <= out4(31);
	out5(18) <= out4(32) XOR out4(33);
	out5(19) <= out4(34) XOR out4(35);
	out5(20) <= out4(36);
	out5(21) <= out4(19) XOR out4(37);
	out5(22) <= out4(38) XOR out4(39);
	out5(23) <= out4(40) XOR out4(41);
	out5(24) <= out4(42) XOR out4(43);
	out5(25) <= out4(44) XOR out4(45);
	out5(26) <= out4(46) XOR out4(47);
	out5(27) <= out4(11) XOR out4(48);
	out5(28) <= out4(49) XOR out4(50);
	out5(29) <= out4(4) XOR out4(51);
	out5(30) <= out4(52) XOR out4(53);
	out5(31) <= out4(54) XOR out4(55);
	out5(32) <= out4(56) XOR out4(57);
	out5(33) <= out4(58) XOR out4(59);
	out5(34) <= out4(60) XOR out4(61);
	out5(35) <= out4(62) XOR out4(63);
	out5(36) <= out4(64) XOR out4(65);
	out5(37) <= out4(66) XOR out4(67);
	out5(38) <= out4(68) XOR out4(69);
	out5(39) <= out4(70) XOR out4(71);
	out5(40) <= out4(72) XOR out4(73);
	out5(41) <= out4(74) XOR out4(75);
	out5(42) <= out4(76) XOR out4(77);
	out5(43) <= out4(78);
	out5(44) <= out4(79) XOR out4(80);
	out5(45) <= out4(81) XOR out4(82);
	out5(46) <= out4(83);
	out5(47) <= out4(84) XOR out4(85);
	out5(48) <= out4(86) XOR out4(87);
	out5(49) <= out4(88) XOR out4(89);
	out5(50) <= out4(90) XOR out4(91);
	out5(51) <= out4(92);
	out5(52) <= out4(93) XOR out4(94);
	out5(53) <= out4(95) XOR out4(96);
	out5(54) <= out4(97);
	out5(55) <= out4(98) XOR out4(99);
	out5(56) <= out4(100) XOR out4(101);
	out5(57) <= out4(102) XOR out4(103);
	out5(58) <= out4(104) XOR out4(105);
	out5(59) <= out4(106);
	out5(60) <= out4(107) XOR out4(108);
	out5(61) <= out4(109) XOR out4(110);
	out5(62) <= out4(111);
	out5(63) <= out4(112) XOR out4(113);
	out5(64) <= out4(114) XOR out4(115);
	out5(65) <= out4(116) XOR out4(117);
	out5(66) <= out4(118) XOR out4(119);
	out5(67) <= out4(120) XOR out4(121);
	out5(68) <= out4(122) XOR out4(123);
	out5(69) <= out4(124) XOR out4(125);
	out5(70) <= out4(126) XOR out4(127);
	out5(71) <= out4(128) XOR out4(129);
	out5(72) <= out4(130) XOR out4(131);

	out6(0) <= out5(0) XOR out5(1);
	out6(1) <= out5(2) XOR out5(3);
	out6(2) <= out5(4) XOR out5(5);
	out6(3) <= out5(6) XOR out5(7);
	out6(4) <= out5(8) XOR out5(9);
	out6(5) <= out5(10) XOR out5(11);
	out6(6) <= out5(12) XOR out5(13);
	out6(7) <= out5(14);
	out6(8) <= out5(15) XOR out5(16);
	out6(9) <= out5(17);
	out6(10) <= out5(18) XOR out5(19);
	out6(11) <= out5(20);
	out6(12) <= out5(21) XOR out5(22);
	out6(13) <= out5(23) XOR out5(24);
	out6(14) <= out5(25) XOR out5(26);
	out6(15) <= out5(27) XOR out5(28);
	out6(16) <= out5(29) XOR out5(30);
	out6(17) <= out5(31) XOR out5(32);
	out6(18) <= out5(33) XOR out5(34);
	out6(19) <= out5(35) XOR out5(36);
	out6(20) <= out5(37) XOR out5(38);
	out6(21) <= out5(39) XOR out5(40);
	out6(22) <= out5(41) XOR out5(42);
	out6(23) <= out5(43);
	out6(24) <= out5(44) XOR out5(45);
	out6(25) <= out5(46);
	out6(26) <= out5(47) XOR out5(48);
	out6(27) <= out5(49) XOR out5(50);
	out6(28) <= out5(51);
	out6(29) <= out5(52) XOR out5(53);
	out6(30) <= out5(54);
	out6(31) <= out5(55) XOR out5(56);
	out6(32) <= out5(57) XOR out5(58);
	out6(33) <= out5(59);
	out6(34) <= out5(60) XOR out5(61);
	out6(35) <= out5(62);
	out6(36) <= out5(63) XOR out5(64);
	out6(37) <= out5(65) XOR out5(66);
	out6(38) <= out5(67) XOR out5(68);
	out6(39) <= out5(69) XOR out5(70);
	out6(40) <= out5(71) XOR out5(72);

	out7(0) <= out6(0);
	out7(1) <= out6(1);
	out7(2) <= out6(2);
	out7(3) <= out6(3);
	out7(4) <= out6(4);
	out7(5) <= out6(5);
	out7(6) <= out6(6) XOR out6(7);
	out7(7) <= out6(8) XOR out6(9);
	out7(8) <= out6(10) XOR out6(11);
	out7(9) <= out6(12);
	out7(10) <= out6(13);
	out7(11) <= out6(14);
	out7(12) <= out6(15);
	out7(13) <= out6(16);
	out7(14) <= out6(17);
	out7(15) <= out6(18);
	out7(16) <= out6(19);
	out7(17) <= out6(20);
	out7(18) <= out6(21);
	out7(19) <= out6(22) XOR out6(23);
	out7(20) <= out6(24) XOR out6(25);
	out7(21) <= out6(26);
	out7(22) <= out6(27) XOR out6(28);
	out7(23) <= out6(29) XOR out6(30);
	out7(24) <= out6(31);
	out7(25) <= out6(32) XOR out6(33);
	out7(26) <= out6(34) XOR out6(35);
	out7(27) <= out6(36);
	out7(28) <= out6(37);
	out7(29) <= out6(38);
	out7(30) <= out6(39);
	out7(31) <= out6(40);

	DO(0) <= out7(0);
	DO(1) <= out7(1);
	DO(2) <= out7(2);
	DO(3) <= out7(3);
	DO(4) <= out7(4);
	DO(5) <= out7(5);
	DO(6) <= out7(6);
	DO(7) <= out7(7);
	DO(8) <= out7(8);
	DO(9) <= out7(9);
	DO(10) <= out7(10);
	DO(11) <= out7(11);
	DO(12) <= out7(12);
	DO(13) <= out7(13);
	DO(14) <= out7(14);
	DO(15) <= out7(15);
	DO(16) <= out7(16);
	DO(17) <= out7(17);
	DO(18) <= out7(18);
	DO(19) <= out7(19);
	DO(20) <= out7(20);
	DO(21) <= out7(21);
	DO(22) <= out7(22);
	DO(23) <= out7(23);
	DO(24) <= out7(24);
	DO(25) <= out7(25);
	DO(26) <= out7(26);
	DO(27) <= out7(27);
	DO(28) <= out7(28);
	DO(29) <= out7(29);
	DO(30) <= out7(30);
	DO(31) <= out7(31);

end architecture;
